;*********************************************
; zasilacz cyfrowy
;*********************************************
PX_2 EQU P2.0 ;przekaxnik
PX_1 EQU P2.1 ;przekaxnik
DB_LCD EQU P0
BB_LCD EQU P0.7 ; buzzy beat
RS_LCD EQU P2.5
RW_LCD EQU P2.6
E_LCD EQU P2.7
CLR_LCD EQU 01H
SHIFT_CURSORL EQU 010H
SHIFT_CURSORR EQU 014H
SHIFT_TXTL EQU 018H
SHIFT_TXTR EQU 01CH
CURSOR_ON EQU 00001110B
CURSOR_OFF EQU 00001100B
LINE1_LCD EQU 080H
LINE2_LCD EQU 0C0H
LINE3_LCD EQU 094H
LINE4_LCD EQU 0D4H
EMS_S EQU 06H;entry mod set +shift
EMS_NS EQU 04H;nie przesuwa kur.
CLK EQU P1.6 ;zegar ADC i zasilaczy
STROBE1 EQU P1.5 ;strobe zasilacza nr1
STROBE2 EQU P1.1 ;strobe zasilacza nr2
DATA_OUT1 EQU P1.4 ;dane wysylane do zasilacza nr1
DATA_ADC2 EQU P1.3 ;dane odbierane z ADC zasilacza nr2
DATA_ADC1 EQU P1.7 ;dane odbiernane z ADC zasilacza nr1
DATA_OUT2 EQU P1.0 ;dane wysylane do zasilacza nr2 bylo 1.2
ENTER EQU 01H
UP EQU 02H
DOWN EQU 03H
KEY_ENTER EQU P3.4
KEY_DOWN EQU P3.5
KEY_UP EQU P3.3
KEY EQU 030H; odczyt klawiatury
DELAY_CLK EQU 05H;opoznienie zegara linii sck
DELAY_CLK1 EQU 100;opoznienie dla clk 4094 zasilacza z transoptorem
SDA EQU P3.6 ;DATA eeprom
SCK EQU P3.7 ; scl eeprom i clk ADC
MEM1 EQU 031H; pamiec ram U1
MEM12 EQU 032H;pamiec ram I1
MEM2 EQU 033H;pamiec ram U2
MEM22 EQU 034H;pamiec ram I2
				;Q1 =0 <=>15V ON
				;Q5 =0 <=> 5A 0N
				;******************************
				;Q8 Q7 Q6 Q5 Q4 Q3 Q2 Q1
				;0  0  0  1  X   X  X  X <=> 0,1A
				;0  0  1  1  X   X  X  X <=> 0,8A
				;0  1  0  1  X   X  X  X <=> 0,3A
				;0  1  1  1  X   X  X  X <=> 2A
				;1  0  0  1  X   X  X  X <=> 0,2A
				;1  0  1  1  X   X  X  X <=> 1A
				;1  1  0  1  X   X  X  X <=> 0,5A
				;1  1  1  1  X   X  X  X <=> 3A
MEM_COUNT EQU 035H; ile jest nastaw zapisanych w eeprom
MEM_COUNT_DISP EQU 036H ;ktora komorka mem jest wyswietlana
EEPROM1 EQU 037H	;chwilowe dane eeprom
EEPROM2 EQU 038H	;chwilowe dane eeprom
EEPROM3 EQU 039H	;chwilowe dane eeprom
EEPROM4 EQU 03AH	;chwilowe dane eeprom
EEPROM5 EQU 03BH	;chwilowe dane eeprom
EEPROM6 EQU 03CH	;chwilowe dane eeprom
EEPROM7 EQU 03DH	;chwilowe dane eeprom
TIMER_COUNT EQU 03EH	;pomocniczy rejestr dla pracy timera
TIMER_COUNT1 EQU 03FH	;pomocniczy rejestr dla pracy timera
TIMER_DATA EQU 00	;stala wartosc przelaowania TIMER_COUNT
timer0 EQU 00H ;zawarto TH i TL 
PAM1	EQU 040H	;tymczasowe dane eeprom	
PAM2	EQU 041H	;tymczasowe dane eeprom	
PAM3	EQU 042H	;tymczasowe dane eeprom	
PAM4	EQU 043H	;tymczasowe dane eeprom	
PAM5	EQU 044H	;tymczasowe dane eeprom	
PAM6	EQU 045H	;tymczasowe dane eeprom	
PAM7	EQU 046H	;tymczasowe dane eeprom	
PAM1A	EQU 047H	;tymczasowe dane eeprom	
PAM2A	EQU 048H	;tymczasowe dane eeprom	
PAM3A	EQU 049H	;tymczasowe dane eeprom	
PAM4A	EQU 04AH	;tymczasowe dane eeprom	
PAM5A	EQU 04BH	;tymczasowe dane eeprom	
PAM6A	EQU 04CH	;tymczasowe dane eeprom	
PAM7A	EQU 04DH	;tymczasowe dane eeprom	
;LINE1 EQU 20H.0	; ustawiany gdy kursor w pierwszej linii
;LINE2 EQU 20H.1	; ustawiany gdy kursor w 2 linii lcd
;LINE3 EQU 20H.2	; ustawiany gdy kursor w 3 linii lcd
;LINE4 EQU 20H.3	; ustawiany gdy kursor w 4 linii lcd
;LINE EQU 057H		;bylo 20
CURSOR_COUNT EQU 04EH	;wskaznik pozycji kursora w wieszu
U1_H EQU 04FH		;dziesiatki woltow pomiaru napiecia U1
U1_L EQU 050H		;jednstki woltow pomiaru napiecia U1
U2_H EQU 051H		;dziesiate czesci woltow pomiaru napiecia U1
U2_L EQU 052H		;dziesiatki woltow pomiaru napiecia U2
I1_H EQU 053H		;jednostki woltow pomiaru napiecia U2
I1_L EQU 054H		;dziesiate czesci woltow pomiaru napiecia U2
I2_H EQU 055H		;jednosti pomiaru napiecia I1
I2_L EQU 056H		;x 0,1A I1
;*********************************************************
;ORGANIZACJA PAMIECI EEPROM
;pierwsza kom zawera inf ile jest zapisanych kom pam.
;0: 'N' - NIEZLAEZNE
;   'S' - SZEREGOWE
;   'R' - ROWNOLEGE
;1: U1 Z TABELI TAB_U2 (JESLI FF-WTEDY TAB_U1)
;2: U1 Z TABELI TAB_U1 
;3: I1-MAX
;4: U2 Z TABELI TAB_U2 (JESLI FF-WTEDY TAB_U1)
;5: U2 Z TABELI TAB_U1 
;6: I2-MAX

	AJMP START
;******************************
;obsluga przerwania z INT0
	ORG 03H
	LCALL RD_KEY
	RETI
;obsga przerwania od t0
	ORG 0BH
	PUSH PSW
	PUSH ACC
	MOV A,TIMER_COUNT
	DJNZ ACC,TIMER_END
	MOV A,TIMER_COUNT1
	DJNZ ACC,TIMER_END1
	LCALL TIMER
	MOV A,#0AH	
TIMER_END1:
	MOV TIMER_COUNT1,A
	MOV A,#TIMER_DATA
TIMER_END:
	MOV TIMER_COUNT,A
	POP ACC
	POP PSW
	RETI
	ORG 100H
;****************************************************
;                 program glowny
;****************************************************
START:
	CLR STROBE1
	CLR STROBE2
	MOV B,#01FH; 0.1A
	MOV A,#0FFH; 2,5V
	LCALL SEND1	; wysylanie danych do zasilacza nr1
	MOV B,#01FH; 0.1A
	MOV A,#0FFH; 2,5V
	LCALL SEND2	; wysylanie danych do zasilacza nr2
	SETB PX_1
	CLR PX_2
	LCALL INIT_LCD ; ustawienie trybu pracy matrycy 
	MOV C,KEY_ENTER
	JC START1
	LCALL SERVIS
START1:
	MOV IE,#00000011B
	MOV TMOD,#022H;licznik t0 i t1 w tryb 2 (8bit +przeladowanie th)
	MOV TL0,#timer0
	MOV TH0,#timer0
	CLR EA
	CLR TR0		
	MOV KEY,#00H
	SETB PX_1
	CLR PX_2
	MOV U1_H,#00H		;dziesiatki woltow pomiaru napiecia U1
	MOV U1_L,#03H		;jednstki woltow pomiaru napiecia U1
	MOV U2_H,#045H		;dziesiate czesci woltow pomiaru napiecia U1
	MOV U2_L,#06H		;dziesiatki woltow pomiaru napiecia U2
	MOV I1_H,#078H		;jednostki woltow pomiaru napiecia U2
	MOV I1_L,#09H		;dziesiate czesci woltow pomiaru napiecia U2
	MOV I2_H,#01H		;jednosti pomiaru napiecia I1
	MOV I2_L,#03H		;x 0,1A I1
	LCALL IDENT;nazwa wizytowki
	MOV CURSOR_COUNT,#01H
	MOV R0,#00H
	LCALL READ_MEM
	MOV MEM_COUNT,A	;ile jest zapisanych nastaw w eeprom
	MOV DPTR,#TAB_MENU1
	LCALL MONITOR
;**************************************************************
	MOV MEM_COUNT_DISP,#01H
	MOV R0,#01H
MENU:
	LCALL DATA
	CLR TR0
	MOV A,#LINE1_LCD
	LCALL LCD
;	MOV LINE,#LINE1_LCD
	MOV CURSOR_COUNT,#01H
	MOV A,#SHIFT_CURSORR
	LCALL LCD
	INC CURSOR_COUNT
	MOV A,MEM_COUNT_DISP
	SWAP A
	ANL A,#0FH
	ORL A,#030H
	LCALL WRITE_LCD
	INC CURSOR_COUNT
	MOV A,MEM_COUNT_DISP
	ANL A,#0FH
	ORL A,#030H
	LCALL WRITE_LCD
	INC CURSOR_COUNT
	SETB TR0
	MOV KEY,#00H
MENU1:
	LCALL DELAY10
	MOV A,KEY
	JZ MENU1
	CJNE A,#DOWN,MENU2
	MOV A,MEM_COUNT_DISP
	CJNE A,#01H,MENU1A
	MOV KEY,#00H
	SJMP MENU1
MENU1A:
	MOV A,MEM_COUNT_DISP
	LCALL DEC_BCD	;funkcja dekrementacji w kodzie BCD	
	MOV MEM_COUNT_DISP,A
	MOV A,#13
MENU1B:
	DEC R0
	DJNZ ACC,MENU1B
	LCALL DATA
	CLR TR0
	MOV A,#LINE1_LCD
;	MOV LINE,#LINE1_LCD
	LCALL LCD
	MOV CURSOR_COUNT,#01H
	MOV A,#SHIFT_CURSORR
	LCALL LCD
	INC CURSOR_COUNT
	MOV A,MEM_COUNT_DISP
	SWAP A
	ANL A,#0FH
	ORL A,#030H
	LCALL WRITE_LCD
	INC CURSOR_COUNT
	MOV A,MEM_COUNT_DISP
	ANL A,#0FH
	ORL A,#030H
	LCALL WRITE_LCD
	INC CURSOR_COUNT
	SETB TR0
	MOV KEY,#00H
	SJMP MENU1
MENU2:
	CJNE A,#UP,MENU3
	MOV A,MEM_COUNT_DISP
	CJNE A,MEM_COUNT,MENU2A
	MOV KEY,#00H
	SJMP MENU1
MENU2A:
	MOV A,MEM_COUNT_DISP
	ADD A,#01H
	DA A
	MOV MEM_COUNT_DISP,A
	INC R0
	LCALL DATA
	CLR TR0
	MOV A,#LINE1_LCD
	LCALL LCD
;	MOV LINE,#LINE1_LCD
	MOV CURSOR_COUNT,#01H
	MOV A,#SHIFT_CURSORR
	LCALL LCD
	INC CURSOR_COUNT
	MOV A,MEM_COUNT_DISP
	SWAP A
	ANL A,#0FH
	ORL A,#030H
	LCALL WRITE_LCD
	INC CURSOR_COUNT
	MOV A,MEM_COUNT_DISP
	ANL A,#0FH
	ORL A,#030H
	LCALL WRITE_LCD
	INC CURSOR_COUNT
	SETB TR0
	MOV KEY,#00H
	AJMP MENU1
MENU3:
	CLR TR0	
	MOV A,#LINE1_LCD
	LCALL LCD
;	MOV LINE,#LINE1_LCD
	MOV CURSOR_COUNT,#01H
	MOV B,#16
	MOV A,#SHIFT_CURSORR
MENU3A:
	LCALL LCD
	INC CURSOR_COUNT
	DJNZ B,MENU3A
	MOV A,#'<'
	LCALL WRITE_LCD
	INC CURSOR_COUNT
	SETB TR0
	MOV KEY,#00H
	MOV C,PX_1
	CPL C
	ORL C,PX_2
	JC MENU3B
MENU3A0:
	;		jest w trybie N
	MOV A,#'N'
	MOV EEPROM1,A
	MOV DPTR,#TAB_N
	LCALL DISPLAY_MODE
	SETB PX_1
	CLR PX_2
MENU3A4:
	MOV KEY,#00H
MENU3A1:
	MOV A,KEY
	JZ MENU3A1
	CJNE A,#UP,MENU3A2
	AJMP MENU3C
MENU3A2:
	CJNE A,#DOWN,MENU3A3
	SJMP MENU3B0
MENU3A3:
	CJNE A,#ENTER,MENU3A4
	AJMP MENU4
MENU3B:
	MOV C,PX_1
	JC MENU3C
MENU3B0:
	;		jest w trybie R
	MOV A,#'R'
	MOV EEPROM1,A
	MOV DPTR,#TAB_R
	LCALL DISPLAY_MODE
	MOV A,MEM12
	MOV MEM22,A
	MOV B,A
	MOV A,MEM1
	MOV MEM2,A
	LCALL SEND2
	CLR PX_2
	LCALL DELAY10
	CLR PX_1
MENU3B4:
	MOV KEY,#00H	;R0:=R0+6
MENU3B1:
	MOV A,KEY
	JZ MENU3B1
	CJNE A,#UP,MENU3B2
	SJMP MENU3A0
MENU3B2:
	CJNE A,#DOWN,MENU3B3
	SJMP MENU3C
MENU3B3:
	CJNE A,#ENTER,MENU3B4
	DEC R0	;1
	DEC R0	;2
	DEC R0	;3
	DEC R0	;4
	DEC R0	;5
	LCALL READ_MEM
	MOV EEPROM2,A	;TAB_U2
	MOV EEPROM5,A
	INC R0
	LCALL READ_MEM
	MOV EEPROM3,A	;TAB_U1
	MOV EEPROM6,A
	INC R0
	LCALL READ_MEM
	MOV EEPROM4,A	;TAB_I
	MOV EEPROM7,A
	MOV A,EEPROM2
	CJNE A,#0FFH,MENU3B5
	MOV A,EEPROM4
	ORL A,#01H
	MOV B,A
	MOV A,EEPROM3
	LCALL SEND2
	INC R0
	INC R0
	INC R0
	SJMP MENU4
MENU3B5:
	MOV A,EEPROM4
	ANL A,#0FEH
	MOV B,A
	MOV A,EEPROM2
	LCALL SEND2
	INC R0
	INC R0
	INC R0
	SJMP MENU4
MENU3C:
	;		jest w trybie S
	MOV A,#'S'
	MOV EEPROM1,A
	MOV DPTR,#TAB_S
	LCALL DISPLAY_MODE
	SETB PX_1
	SETB PX_2
MENU3C0:
	MOV KEY,#00H
MENU3C1:
	MOV A,KEY
	JZ MENU3C1
	CJNE A,#UP,MENU3C2
	AJMP MENU3B0
MENU3C2:
	CJNE A,#DOWN,MENU3C3
	AJMP MENU3A0
MENU3C3:
	CJNE A,#ENTER,MENU3C0
MENU4:
	CLR TR0
	MOV A,#LINE1_LCD
	LCALL LCD
;	MOV LINE,#LINE1_LCD
	MOV CURSOR_COUNT,#01H
	MOV B,#16
	MOV A,#SHIFT_CURSORR
MENU4A:
	LCALL LCD
	INC CURSOR_COUNT
	DJNZ B,MENU4A
	MOV A,#' '
	LCALL WRITE_LCD
	INC CURSOR_COUNT
	MOV A,#LINE2_LCD
	LCALL LCD
;	MOV LINE,#LINE2_LCD
	MOV CURSOR_COUNT,#01H
	MOV B,#8
	MOV A,#SHIFT_CURSORR
MENU4B:
	LCALL LCD
	INC CURSOR_COUNT
	DJNZ B,MENU4B
	MOV A,#'<'
	LCALL WRITE_LCD
	INC CURSOR_COUNT
	MOV A,EEPROM1
	CJNE A,#'R',MENU4B1
	MOV A,#' '
	LCALL WRITE_LCD
	INC CURSOR_COUNT
	MOV A,#'>'
	LCALL WRITE_LCD
	INC CURSOR_COUNT
MENU4B1:
	SETB TR0
;	MOV A,R0
	DEC R0	;1
	DEC R0	;2
	DEC R0	;3
	DEC R0	;4
	DEC R0	;5
	LCALL READ_MEM
	MOV EEPROM2,A
;	MOV A,EEPROM2	;!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
	CJNE A,#0FFH,MENU4C
	INC R0
	LCALL READ_MEM
;	MOV A,EEPROM3	;!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
	MOV B,A
	MOV DPTR,#TAB_U1
	SJMP MENU4D
MENU4C:			;TAB_U2
	LCALL READ_MEM
	MOV B,A
	MOV DPTR,#TAB_U2
	INC R0
MENU4D:
	MOV A,#00H
MENU4E:	
	PUSH ACC
	MOVC A,@A+DPTR
	CJNE A,B,MENU4F	;ustala pozycje w tabelce TAB_U1 lub TAB_U2
	MOV A,EEPROM2	;!!!!!!!!!!!!!!!!!!!!
	CJNE A,#0FFH,MENU5F
	POP ACC
	SJMP MENU5
MENU4F:
	POP ACC
	INC A
	SJMP MENU4E
MENU5:			
	MOV R7,A
	MOV KEY,#00H
MENU5A:
	LCALL DELAY10
	MOV A,KEY
	JZ MENU5A
	CJNE A,#UP,MENU5C
	MOV A,R7
	INC A
	CJNE A,#164,MENU5A1
	SJMP MENU6
MENU5A1:
	PUSH ACC
	MOVC A,@A+DPTR
	MOV MEM1,A
	MOV EEPROM3,A
	MOV B,MEM12
	LCALL SEND1
	MOV A,EEPROM1
	CJNE A,#'R',MENU5B
	MOV A,MEM1
	MOV MEM2,A
	MOV EEPROM6,A
	MOV B,A
	MOV A,MEM12
	MOV MEM22,A
	XCH A,B
	LCALL SEND2
MENU5B:
	POP ACC
	SJMP MENU5
MENU5C:
	CJNE A,#DOWN,MENU5E
	MOV A,R7
	JNZ MENU5D
	MOV KEY,#00H
	SJMP MENU5A	
MENU5D:	
	DEC A
	SJMP MENU5A1
MENU5E:			;ENTER!!!!!!!!!!!!!!
	CJNE A,#ENTER,MENU5E1
	AJMP MENU7
MENU5E1:
	MOV KEY,#00H
	SJMP MENU5A
MENU5F:
	POP ACC
	SJMP MENU6A0
MENU6:			;przeskoczylo na TAB_U2
	MOV A,#00H
MENU6A0:
	MOV DPTR,#TAB_U2
	PUSH ACC
	MOVC A,@A+DPTR
	MOV MEM1,A
	MOV EEPROM2,A
	MOV B,MEM12
	XCH A,B
	ANL A,#0FEH
	MOV MEM12,A
	XCH A,B
	LCALL SEND1
	MOV A,EEPROM1
	CJNE A,#'R',MENU6C
	MOV A,MEM1
	MOV MEM2,A
	MOV EEPROM5,A
	MOV B,A
	MOV A,MEM12
	MOV MEM22,A
	XCH A,B
	LCALL SEND2
	POP ACC
	MOV R7,A
	MOV KEY,#00H
MENU6A:
	LCALL DELAY10
	MOV A,KEY
	JZ MENU6A
	CJNE A,#UP,MENU6D
	MOV A,R7
	INC A
	CJNE A,#114,MENU6B
	DEC A
	MOV KEY,#00H
	SJMP MENU6A
MENU6B:
	PUSH ACC
	MOVC A,@A+DPTR
	MOV MEM1,A
	MOV EEPROM2,A
	MOV B,MEM12
	LCALL SEND1
	MOV A,EEPROM1
	CJNE A,#'R',MENU6C
	MOV A,MEM1
	MOV MEM2,A
	MOV EEPROM5,A
	MOV B,A
	MOV A,MEM12
	MOV MEM22,A
	XCH A,B
	LCALL SEND2
MENU6C:
	POP ACC
	MOV R7,A
	MOV KEY,#00H
	SJMP MENU6A
MENU6D:
	CJNE A,#DOWN,MENU6E
	MOV A,R7
	DEC A
	CJNE A,#0FFH,MENU6B
	MOV EEPROM2,#0FFH
	MOV DPTR,#TAB_U1
	MOV A,MEM12
	ORL A,#01H
	MOV MEM12,A;	wyzerowanie bitu B.0 - 17,5V
	MOV A,EEPROM1
	CJNE A,#'R',MENU6D1
	MOV EEPROM5,#0FFH
	MOV A,MEM22
	ORL A,#01H
	MOV MEM22,A;	wyzerowanie bitu B.0 - 17,5V
MENU6D1:
	MOV A,#163	;!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
	MOV R7,A
	MOV KEY,#00H
	AJMP MENU5A1
MENU6E:			;ENTER
	CJNE A,#ENTER,MENU6E1
	SJMP MENU7
MENU6E1:
	MOV KEY,#00H
	SJMP MENU6A
MENU7:	
	CLR TR0		;		
	MOV A,#LINE2_LCD
	LCALL LCD
;	MOV LINE,#LINE2_LCD
	MOV CURSOR_COUNT,#01H
	MOV B,#8
	MOV A,#SHIFT_CURSORR
MENU7A:
	LCALL LCD
	INC CURSOR_COUNT
	DJNZ B,MENU7A
	MOV A,#' '
	LCALL WRITE_LCD
	INC CURSOR_COUNT
	MOV A,EEPROM1
	CJNE A,#'R',MENU7B
	SETB TR0
	AJMP MENU10;							!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
MENU7B:
	MOV A,#SHIFT_CURSORR
	LCALL LCD
	INC CURSOR_COUNT
	MOV A,#'>'
	LCALL WRITE_LCD
	INC CURSOR_COUNT
	SETB TR0
	INC R0	;4
	INC R0	;5
	LCALL READ_MEM
	MOV EEPROM5,A
;	MOV A,EEPROM5;!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
	CJNE A,#0FFH,MENU7C
	INC R0
	LCALL READ_MEM
;	MOV A,EEPROM6;!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
	MOV B,A
	MOV DPTR,#TAB_U1
	SJMP MENU7D
MENU7C:			;TAB_U2
	MOV B,A
	MOV DPTR,#TAB_U2
	INC R0
MENU7D:
	MOV A,#00H
MENU7E:	
	PUSH ACC
	MOVC A,@A+DPTR
	CJNE A,B,MENU7F	;ustala pozycje w tabelce TAB_U1 lub TAB_U2
	MOV A,EEPROM5	;!!!!!!!!!!!!!!!!!!!!
	CJNE A,#0FFH,MENU8F
	POP ACC
	SJMP MENU8
MENU7F:
	POP ACC
	INC A
	SJMP MENU7E
MENU8:			
	MOV R7,A
	MOV KEY,#00H
MENU8A:
	LCALL DELAY10
	MOV A,KEY
	JZ MENU8A
	CJNE A,#UP,MENU8C
	MOV A,R7
	INC A
	CJNE A,#164,MENU8A1
	SJMP MENU9
MENU8A1:
	PUSH ACC
	MOVC A,@A+DPTR
	MOV MEM2,A
	MOV EEPROM6,A
	MOV B,A
	MOV A,MEM22
	XCH A,B
	LCALL SEND2
MENU8B:
	POP ACC
	SJMP MENU8
MENU8C:
	CJNE A,#DOWN,MENU8E
	MOV A,R7
	JNZ MENU8D
	MOV KEY,#00H
	SJMP MENU8A	
MENU8D:	
	DEC A
	SJMP MENU8A1
MENU8E:			;ENTER!!!!!!!!!!!!!!
	CJNE A,#ENTER,MENU8E1
	AJMP MENU10	;!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
MENU8E1:
	MOV KEY,#00H
	SJMP MENU8A
MENU8F:
	POP ACC
	SJMP MENU9A0
MENU9:			;przeskoczylo na TAB_U2
	MOV A,#00H
MENU9A0:
	MOV DPTR,#TAB_U2
	PUSH ACC
	MOVC A,@A+DPTR
	MOV MEM2,A
	MOV EEPROM5,A
	MOV B,A
	MOV A,MEM22
	ANL A,#0FEH;!!!!!!!!!!!!!!!!!!!!!!!!!!!
	MOV MEM22,A
	XCH A,B
	LCALL SEND2
	POP ACC
	MOV R7,A
	MOV KEY,#00H
MENU9A:
	LCALL DELAY10
	MOV A,KEY
	JZ MENU9A
	CJNE A,#UP,MENU9D
	MOV A,R7
	INC A
	CJNE A,#114,MENU9B
	DEC A
	MOV KEY,#00H
	SJMP MENU9A
MENU9B:
	PUSH ACC
	MOVC A,@A+DPTR
	MOV MEM2,A
	MOV EEPROM5,A
	MOV B,A
	MOV A,MEM22
	XCH A,B
	LCALL SEND2
MENU9C:
	POP ACC
	MOV R7,A
	MOV KEY,#00H
	SJMP MENU9A
MENU9D:
	CJNE A,#DOWN,MENU9E
	MOV A,R7
	DEC A
	CJNE A,#0FFH,MENU9B
	MOV DPTR,#TAB_U1
	MOV EEPROM5,#0FFH
	MOV A,MEM22
	ORL A,#01H
	MOV MEM22,A;	wyzerowanie bitu B.0 - 17,5V
MENU9D1:
	MOV A,#163	;!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
	MOV R7,A
	MOV KEY,#00H
	AJMP MENU8A1
MENU9E:			;ENTER
	CJNE A,#ENTER,MENU9E1
	SJMP MENU10
MENU9E1:
	MOV KEY,#00H
	SJMP MENU9A
MENU10:			;regulacja Imax
	CLR TR0
	MOV A,#LINE2_LCD
	LCALL LCD
;	MOV LINE,#LINE2_LCD
	MOV CURSOR_COUNT,#01H
	MOV B,#10
	MOV A,#SHIFT_CURSORR
MENU10A:
	LCALL LCD
	INC CURSOR_COUNT
	DJNZ B,MENU10A
	MOV A,#' '
	LCALL WRITE_LCD
	INC CURSOR_COUNT
	MOV A,#LINE4_LCD
;	MOV LINE,#LINE4_LCD
	LCALL LCD
	MOV CURSOR_COUNT,#01H
	MOV B,#9
	MOV A,#SHIFT_CURSORR
MENU10B:
	LCALL LCD
	INC CURSOR_COUNT
	DJNZ B,MENU10B
	MOV A,#'<'
	LCALL WRITE_LCD
	INC CURSOR_COUNT
	MOV A,EEPROM1
	CJNE A,#'R',MENU10C
	MOV A,#'>'
	LCALL WRITE_LCD
	INC CURSOR_COUNT
MENU10C:
	SETB TR0
	MOV B,MEM12	
	MOV A,B
	ANL A,#01H
	MOV R5,A	;	zapamietanie B.0 +17,5V
	MOV A,B
	ORL A,#01H
	MOV B,A
	MOV DPTR,#TAB_I
	MOV A,#00H
	MOV R6,#00H
MENU10D:
	PUSH ACC
	MOVC A,@A+DPTR
	CJNE A,B,MENU10E
	POP ACC
	MOV R7,A
	MOV KEY,#00H
	SJMP MENU11
MENU10E:
	POP ACC
	INC A
	INC R6
	INC R6
	INC R6
	SJMP MENU10D
MENU11:
	MOV A,KEY
	JZ MENU11
	CJNE A,#UP,MENU11F
	MOV A,R7
	CJNE A,#8,MENU11E	;koniec zakresu
	MOV KEY,#00H
	AJMP MENU11
MENU11F:
	AJMP MENU12
MENU11E:
	INC A
	MOV R7,A
	MOVC A,@A+DPTR
	ORL A,R5
	MOV B,A
	MOV EEPROM4,A
	MOV A,MEM1
	MOV MEM12,B
	LCALL SEND1
	MOV A,EEPROM1
	CJNE A,#'R',MENU11A
	MOV MEM2,MEM1
	MOV MEM22,MEM12
	MOV A,MEM2
	MOV B,MEM22
	MOV EEPROM7,B
	LCALL SEND2
MENU11A:
	CLR TR0
	MOV A,#LINE4_LCD
	LCALL LCD
;	MOV LINE,#LINE4_LCD
	MOV CURSOR_COUNT,#01H
	MOV B,#5
	MOV A,#SHIFT_CURSORR
	INC R6
	INC R6
	INC R6
MENU11B:
	LCALL LCD
	INC CURSOR_COUNT
	DJNZ B,MENU11B
	MOV DPTR,#TAB_SERV2
	MOV A,R6
	PUSH ACC
	MOVC A,@A+DPTR
	MOV R1,A
	LCALL WRITE_LCD
	INC CURSOR_COUNT
	POP ACC
	INC A
	PUSH ACC
	MOVC A,@A+DPTR
	MOV R2,A
	LCALL WRITE_LCD
	INC CURSOR_COUNT
	POP ACC
	INC A
	MOVC A,@A+DPTR
	MOV R3,A
	LCALL WRITE_LCD
	INC CURSOR_COUNT
	MOV A,EEPROM1
	CJNE A,#'R',MENU11D
	CLR TR0
	MOV B,#8
	MOV A,#SHIFT_CURSORR
MENU11C:
	LCALL LCD
	INC CURSOR_COUNT
	DJNZ B,MENU11C
	MOV A,R1
	LCALL WRITE_LCD
	INC CURSOR_COUNT
	MOV A,R2
	LCALL WRITE_LCD
	INC CURSOR_COUNT
	MOV A,R3
	LCALL WRITE_LCD
	INC CURSOR_COUNT
MENU11D:
	SETB TR0
	MOV KEY,#00H
	MOV DPTR,#TAB_I
	AJMP MENU11
MENU11G:
	AJMP MENU13
MENU12:
	CJNE A,#DOWN,MENU11G
	MOV A,R7
	JNZ MENU12A0
	MOV KEY,#00H
	AJMP MENU11
MENU12A0:
	DEC A
	MOV R7,A
	MOVC A,@A+DPTR
	ORL A,R5
	MOV B,A
	MOV EEPROM4,A
	MOV A,MEM1
	MOV MEM12,B
	LCALL SEND1
	MOV A,EEPROM1
	CJNE A,#'R',MENU12A
	MOV MEM2,MEM1
	MOV MEM22,MEM12
	MOV A,MEM2
	MOV B,MEM22
	MOV EEPROM7,B
	LCALL SEND2
MENU12A:
	CLR TR0
	MOV A,#LINE4_LCD
	LCALL LCD
;	MOV LINE,#LINE4_LCD
	MOV CURSOR_COUNT,#01H
	MOV B,#5
	MOV A,#SHIFT_CURSORR
	DEC R6
	DEC R6
	DEC R6
	AJMP MENU11B
MENU13:
	CJNE A,#ENTER,MENU13A
	SJMP MENU13B
MENU13A:
	MOV KEY,#00H
	AJMP MENU11
MENU13B:				;reg. Imax zas. nr 2
	MOV A,EEPROM1
	CJNE A,#'R',MENU13C
	SJMP MENU15;!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
MENU13C:
	MOV A,#LINE4_LCD
	LCALL LCD
;	MOV LINE,#LINE4_LCD
	MOV CURSOR_COUNT,#01H
	MOV B,#9
	MOV A,#SHIFT_CURSORR
MENU13D:
	LCALL LCD
	INC CURSOR_COUNT
	DJNZ B,MENU13D
	MOV A,#' '
	LCALL WRITE_LCD
	INC CURSOR_COUNT
	MOV A,#'>'
	LCALL WRITE_LCD
	INC CURSOR_COUNT
	SETB TR0
;******************************************************************************

MENU14C:
	MOV B,MEM22	
	MOV A,B
	ANL A,#01H
	MOV R5,A	;	zapamietanie B.0 +17,5V
	MOV A,B
	ORL A,#01H
	MOV B,A
	MOV DPTR,#TAB_I
	MOV A,#00H
	MOV R6,#00H
MENU14D:
	PUSH ACC
	MOVC A,@A+DPTR
	CJNE A,B,MENU14E
	POP ACC
	MOV R7,A
	MOV KEY,#00H
	SJMP MENU15
MENU14E:
	POP ACC
	INC A
	INC R6
	INC R6
	INC R6
	SJMP MENU14D
MENU15:
	MOV A,KEY
	JZ MENU15
	CJNE A,#UP,MENU15F
	MOV A,R7
	CJNE A,#8,MENU15E	;koniec zakresu
	MOV KEY,#00H
	SJMP MENU15
MENU15F:
	SJMP MENU16
MENU15E:
	INC A
	MOV R7,A
	MOVC A,@A+DPTR
	ORL A,R5
	MOV B,A
	MOV EEPROM7,A
	MOV MEM22,B
	MOV A,MEM2
	LCALL SEND2
MENU15A:
	CLR TR0
	MOV A,#LINE4_LCD
	LCALL LCD
;	MOV LINE,#LINE4_LCD
	MOV CURSOR_COUNT,#01H
	MOV B,#16
	MOV A,#SHIFT_CURSORR
	INC R6
	INC R6
	INC R6
MENU15B:
	LCALL LCD
	INC CURSOR_COUNT
	DJNZ B,MENU15B
	MOV DPTR,#TAB_SERV2
	MOV A,R6
	PUSH ACC
	MOVC A,@A+DPTR
	LCALL WRITE_LCD
	INC CURSOR_COUNT
	POP ACC
	INC A
	PUSH ACC
	MOVC A,@A+DPTR
	LCALL WRITE_LCD
	INC CURSOR_COUNT
	POP ACC
	INC A
	MOVC A,@A+DPTR
	LCALL WRITE_LCD
	INC CURSOR_COUNT
	SETB TR0
	MOV A,EEPROM1
	MOV KEY,#00H
	MOV DPTR,#TAB_I
	LJMP MENU15
MENU15G:
	LJMP MENU17
MENU16:
	CJNE A,#DOWN,MENU15G
	MOV A,R7
	JNZ MENU16A0
	MOV KEY,#00H
	LJMP MENU15
MENU16A0:
	DEC A
	MOV R7,A
	MOVC A,@A+DPTR
	ORL A,R5
	MOV B,A
	MOV EEPROM7,A
	MOV A,MEM2
	MOV MEM22,B
	LCALL SEND2
MENU16A:
	CLR TR0
	MOV A,#LINE4_LCD
	LCALL LCD
;	MOV LINE,#LINE4_LCD
	MOV CURSOR_COUNT,#01H
	MOV B,#16
	MOV A,#SHIFT_CURSORR
	DEC R6
	DEC R6
	DEC R6
	LJMP MENU15B
;*************************************************************************************
MENU17:				;	zapisanie do mem
	CLR TR0
	MOV A,#LINE1_LCD
	LCALL LCD
;	MOV LINE,#LINE1_LCD
	MOV CURSOR_COUNT,#01H
	MOV DPTR,#TAB_MENU2
	MOV A,#00H
MENU17A:
	PUSH ACC
	MOVC A,@A+DPTR
	LCALL WRITE_LCD
	INC CURSOR_COUNT
	SETB TR0
	POP ACC
	INC A
	CJNE A,#20,MENU17A
	MOV KEY,#00H
MENU17B:
	MOV A,KEY
	JZ MENU17B
	CJNE A,#UP,MENU18
MENU17H:
	CLR TR0
	MOV A,#LINE1_LCD
	LCALL LCD
;	MOV LINE,#LINE1_LCD
	MOV CURSOR_COUNT,#01H
	MOV DPTR,#TAB_MENU3
	MOV A,#00H
MENU17C:
	PUSH ACC
	MOVC A,@A+DPTR
	LCALL WRITE_LCD
	MOV CURSOR_COUNT,#01H
	SETB TR0
	POP ACC
	INC A
	CJNE A,#20,MENU17C
	MOV KEY,#00H
MENU17D:
	MOV A,KEY
	JZ MENU17D
	CJNE A,#UP,MENU19
MENU17G:
	CLR TR0
	MOV A,#LINE1_LCD
	LCALL LCD
;	MOV LINE,#LINE1_LCD
	MOV CURSOR_COUNT,#01H
	MOV DPTR,#TAB_MENU4
	MOV A,#00H
MENU17E:
	PUSH ACC
	MOVC A,@A+DPTR
	LCALL WRITE_LCD
	INC CURSOR_COUNT
	SETB TR0
	POP ACC
	INC A
	CJNE A,#20,MENU17E
	MOV KEY,#00H
MENU17F:
	MOV A,KEY
	JZ MENU17F
	CJNE A,#UP,MENU20
	AJMP MENU17
MENU18:
	CJNE A,#DOWN,MENU18A
	MOV KEY,#00H
	SJMP MENU17G
MENU18A:			;ZAPIS DO MEM
	MOV DPTR,#TAB_MENU1
	LCALL MONITOR
	MOV R0,#01H
	MOV A,MEM_COUNT_DISP
MENU18B:
	LCALL DEC_BCD
	JNZ MENU18C
;	MOV A,#LINE1_LCD		;!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
;	MOV A,R0			;!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
;	LCALL DISPLAY_BIT		;!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
;	SJMP $;!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
	LCALL EEPROM_WRITE
	DEC R0
	DEC R0
	DEC R0
	DEC R0
	DEC R0
	DEC R0
;	CLR REG_BIT
	LJMP MENU
MENU18C:
	PUSH ACC
	MOV A,R0
	ADD A,#07H
	MOV R0,A
	POP ACC
	SJMP MENU18B
MENU19:
	CJNE A,#DOWN,MENU19A
	MOV KEY,#00H
	LJMP MENU17
MENU19A:			;WROCOC DO REG.
	MOV DPTR,#TAB_MENU1
	LCALL MONITOR
	MOV R0,#01H
	MOV A,MEM_COUNT_DISP
MENU19B:
	LCALL DEC_BCD
	JNZ MENU19C
	LCALL EEPROM_WRITE
	DEC R0
	DEC R0
	DEC R0
	DEC R0
	DEC R0
	DEC R0
;	SETB REG_BIT
	SJMP MENU21
MENU19C:
	PUSH ACC
	MOV A,R0
	ADD A,#07H
	MOV R0,A
	POP ACC
	SJMP MENU19B
MENU20:
	CJNE A,#DOWN,MENU20A
	MOV KEY,#00H
	LJMP MENU17H
MENU20A:			;WROCOC DO pierwotnego stanu eeprom.
	MOV DPTR,#TAB_MENU1
	LCALL MONITOR
	MOV R0,#01H
	MOV A,MEM_COUNT_DISP
MENU20B:
	LCALL DEC_BCD
	JNZ MENU20C
	LCALL PAM_WRITE	;wpisanie do eeprom pierwotnych wartosci
	DEC R0
	DEC R0
	DEC R0
	DEC R0
	DEC R0
	DEC R0
;	CLR REG_BIT
	LJMP MENU
MENU20C:
	PUSH ACC
	MOV A,R0
	ADD A,#07H
	MOV R0,A
	POP ACC
	SJMP MENU20B
MENU21:
	CLR TR0
	MOV A,#LINE1_LCD
	LCALL LCD
;	MOV LINE,#LINE1_LCD
	MOV CURSOR_COUNT,#01H
	MOV A,#SHIFT_CURSORR
	LCALL LCD
	INC CURSOR_COUNT
	MOV A,MEM_COUNT_DISP
	SWAP A
	ANL A,#0FH
	ORL A,#030H
	LCALL WRITE_LCD
	INC CURSOR_COUNT
	MOV A,MEM_COUNT_DISP
	ANL A,#0FH
	ORL A,#030H
	LCALL WRITE_LCD
	INC CURSOR_COUNT
	SETB TR0

	LCALL READ_MEM
	LCALL CH_MODE

	INC R0

	PUSH DPH
	PUSH DPL
	MOV B,#0FFH
	LCALL READ_MEM ;U1 Z TABELI TAB_U2 (JESLI FF-WTEDY TAB_U1)
;	MOV PAM2,A		;!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
	CJNE A,#0FFH,MU_MEM1
	INC R0
	LCALL READ_MEM ;U1 Z TABELI TAB_U1
;	MOV PAM3,A		;!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
	MOV MEM1,A ;	 pamiec ram U1
	SJMP MU_MEM2
MU_MEM1:
	MOV B,#0FEH
	MOV MEM1,A ; pamiec ram U1
	INC R0
MU_MEM2:
	INC R0
	LCALL READ_MEM	 ;I1-MAX
;	MOV PAM4,A		;!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
	XCH A,B
	MOV C,ACC.0
	XCH A,B
	MOV ACC.0,C
	MOV MEM12,A		;pamiec ram I1
	INC R0
	MOV B,#0FFH
	LCALL READ_MEM ;U2 Z TABELI TAB_U2 (JESLI FF-WTEDY TAB_U1)
;	MOV PAM5,A		;!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
	CJNE A,#0FFH,MU_MEM3
	INC R0
	LCALL READ_MEM ;U2 Z TABELI TAB_U1
;	MOV PAM6,A		;!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
	MOV MEM2,A ;	 pamiec ram U2
	SJMP MU_MEM4
MU_MEM3:
	MOV B,#0FEH
	MOV MEM2,A ; pamiec ram U2
	INC R0
MU_MEM4:
	INC R0
	LCALL READ_MEM	 ;I2-MAX
;	MOV PAM7,A		;!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
	XCH A,B
	MOV C,ACC.0
	XCH A,B
	MOV ACC.0,C
	MOV MEM22,A		;pamiec ram I2
	CLR TR0
	MOV A,#LINE4_LCD
	LCALL LCD
;	MOV LINE,#LINE4_LCD
	MOV CURSOR_COUNT,#01H
	MOV B,#05H
MU_MEM4A:
	MOV A,#SHIFT_CURSORR
	LCALL LCD
	INC CURSOR_COUNT
	DJNZ B,MU_MEM4A
	SETB TR0
	MOV A,MEM12
	ORL A,#01H
	CJNE A,#00011111B,MU_MEM5A; 0,1A
	MOV A,#00H
	SJMP MU_MEM6
MU_MEM5A:
	CJNE A,#10011111B,MU_MEM5B;	0,2A
	MOV A,#03H
	SJMP MU_MEM6
MU_MEM5B:
	CJNE A,#01011111B,MU_MEM5C;	0,3A
	MOV A,#06H
	SJMP MU_MEM6
MU_MEM5C:
	CJNE A,#11011111B,MU_MEM5D;	0,5A
	MOV A,#09H
	SJMP MU_MEM6
MU_MEM5D:
	CJNE A,#00111111B,MU_MEM5E;	0,8A
	MOV A,#12
	SJMP MU_MEM6
MU_MEM5E:
	CJNE A,#10111111B,MU_MEM5F;	1,0A
	MOV A,#15
	SJMP MU_MEM6
MU_MEM5F:
	CJNE A,#01111111B,MU_MEM5G;	2,0A
	MOV A,#18
	SJMP MU_MEM6
MU_MEM5G:
	CJNE A,#0FFH,MU_MEM5H;	3,0A
	MOV A,#21
	SJMP MU_MEM6
MU_MEM5H:
	MOV A,#24
MU_MEM6:
	MOV DPTR,#TAB_SERV2
	CLR TR0
	PUSH ACC
	MOVC A,@A+DPTR
	LCALL WRITE_LCD
	INC CURSOR_COUNT
	MOV A,#SHIFT_CURSORR
	LCALL LCD
	INC CURSOR_COUNT
	POP ACC
	INC A
	INC A
	MOVC A,@A+DPTR
	LCALL WRITE_LCD
	INC CURSOR_COUNT
	MOV B,#08H
MU_MEM6A1:
	MOV A,#SHIFT_CURSORR
	LCALL LCD
	INC CURSOR_COUNT
	DJNZ B,MU_MEM6A1
	SETB TR0
	MOV A,MEM22
	ORL A,#01H
	CJNE A,#00011111B,MU_MEM6A; 0,1A
	MOV A,#00H
	SJMP MU_MEM7
MU_MEM6A:
	CJNE A,#10011111B,MU_MEM6B;	0,2A
	MOV A,#03H
	SJMP MU_MEM7
MU_MEM6B:
	CJNE A,#01011111B,MU_MEM6C;	0,3A
	MOV A,#06H
	SJMP MU_MEM7
MU_MEM6C:
	CJNE A,#11011111B,MU_MEM6D;	0,5A
	MOV A,#09H
	SJMP MU_MEM7
MU_MEM6D:
	CJNE A,#00111111B,MU_MEM6E;	0,8A
	MOV A,#12
	SJMP MU_MEM7
MU_MEM6E:
	CJNE A,#10111111B,MU_MEM6F;	1,0A
	MOV A,#15
	SJMP MU_MEM7
MU_MEM6F:
	CJNE A,#01111111B,MU_MEM6G;	2,0A
	MOV A,#18
	SJMP MU_MEM7
MU_MEM6G:
	CJNE A,#0FFH,MU_MEM6H;	3,0A
	MOV A,#21
	SJMP MU_MEM7
MU_MEM6H:
	MOV A,#24
MU_MEM7:
	MOV DPTR,#TAB_SERV2
	CLR TR0
	PUSH ACC
	MOVC A,@A+DPTR
	LCALL WRITE_LCD
	INC CURSOR_COUNT
	MOV A,#SHIFT_CURSORR
	LCALL LCD
	INC CURSOR_COUNT
	POP ACC
	INC A
	INC A
	MOVC A,@A+DPTR
	LCALL WRITE_LCD
	INC CURSOR_COUNT
	SETB TR0
	MOV A,MEM1
	MOV B,MEM12
	LCALL SEND1
	MOV A,MEM2
	MOV B,MEM22
	LCALL SEND2
	POP DPL
	POP DPH
	MOV KEY,#00H
	LJMP MENU3
;***************************************************************
TIMER:
	CLR TR0
	PUSH PSW
;	CLR P2.3
	;***************************************************
	ACALL TIMER_CLK_L
	ACALL TIMER_CLK_L
	ACALL TIMER_CLK_L
	ACALL TIMER_CLK_L
	ACALL TIMER_CLK_L
	;***************************************************
	ACALL TIMER_CLK_H
	;**************************************************
	MOV C,DATA_ADC1		;odczyt danych z ADC1.7
	RLC A
	MOV U1_H,A
	MOV C,DATA_ADC2		;odczyt danych z ADC2.7
	CPL C
	RLC A
	MOV U2_H,A
	;***************************************************
	ACALL TIMER_CLK_L
	;***************************************************
	ACALL TIMER_CLK_H
	;**************************************************
	MOV C,DATA_ADC1		;odczyt danych z ADC1.6
	MOV A,U1_H
	RLC A
	MOV U1_H,A
	MOV C,DATA_ADC2		;odczyt danych z ADC2.6
	CPL C
	MOV A,U2_H
	RLC A
	MOV U2_H,A
	;***************************************************
	ACALL TIMER_CLK_L
	;***************************************************
	ACALL TIMER_CLK_H
	;**************************************************
	MOV C,DATA_ADC1		;odczyt danych z ADC1.5
	MOV A,U1_H
	RLC A
	MOV U1_H,A
	MOV C,DATA_ADC2		;odczyt danych z ADC2.5
	CPL C
	MOV A,U2_H
	RLC A
	MOV U2_H,A
	;***************************************************
	ACALL TIMER_CLK_L
	;***************************************************
	ACALL TIMER_CLK_H
	;**************************************************
	MOV C,DATA_ADC1		;odczyt danych z ADC1.4
	MOV A,U1_H
	RLC A
	MOV U1_H,A
	MOV C,DATA_ADC2		;odczyt danych z ADC2.4
	CPL C
	MOV A,U2_H
	RLC A
	MOV U2_H,A
	;***************************************************
	ACALL TIMER_CLK_L
	;***************************************************
	ACALL TIMER_CLK_H
	;**************************************************
	MOV C,DATA_ADC1		;odczyt danych z ADC1.3
	MOV A,U1_H
	RLC A
	MOV U1_H,A
	MOV C,DATA_ADC2		;odczyt danych z ADC2.3
	CPL C
	MOV A,U2_H
	RLC A
	MOV U2_H,A
	;***************************************************
	ACALL TIMER_CLK_L
	;***************************************************
	ACALL TIMER_CLK_H
	;**************************************************
	MOV C,DATA_ADC1		;odczyt danych z ADC1.2
	MOV A,U1_H
	RLC A
	MOV U1_H,A
	MOV C,DATA_ADC2		;odczyt danych z ADC2.2
	CPL C
	MOV A,U2_H
	RLC A
	MOV U2_H,A
	;***************************************************
	ACALL TIMER_CLK_L
	;***************************************************
	ACALL TIMER_CLK_H
	;**************************************************
	MOV C,DATA_ADC1		;odczyt danych z ADC1.1
	MOV A,U1_H
	RLC A
	MOV U1_H,A
	MOV C,DATA_ADC2		;odczyt danych z ADC2.1
	CPL C
	MOV A,U2_H
	RLC A
	MOV U2_H,A
	;***************************************************
	ACALL TIMER_CLK_L
	;***************************************************
	ACALL TIMER_CLK_H
	;**************************************************
	MOV C,DATA_ADC1		;odczyt danych z ADC1.0
	MOV A,U1_H
	RLC A
	MOV U1_H,A
	MOV C,DATA_ADC2		;odczyt danych z ADC2.0
	CPL C
	MOV A,U2_H
	RLC A
	MOV U2_H,A
	;***************************************************
	ACALL TIMER_CLK_L
	;***************************************************
	ACALL TIMER_CLK_H
	;**************************************************
	MOV A,#00H
	MOV C,DATA_ADC1		;odczyt danych z ADC1.3
	MOV ACC.3,C
	MOV U1_L,A
	MOV C,DATA_ADC2		;odczyt danych z ADC2.3
	CPL C
	MOV ACC.3,C
	MOV U2_L,A
	;***************************************************
	ACALL TIMER_CLK_L
	;***************************************************
	ACALL TIMER_CLK_H
	;**************************************************
	MOV A,U1_L
	MOV C,DATA_ADC1		;odczyt danych z ADC1.2
	MOV ACC.2,C
	MOV U1_L,A
	MOV A,U2_L
	MOV C,DATA_ADC2		;odczyt danych z ADC2.2
	CPL C
	MOV ACC.2,C
	MOV U2_L,A
	;***************************************************
	ACALL TIMER_CLK_L
	;***************************************************
	ACALL TIMER_CLK_H
	;**************************************************
	MOV A,U1_L
	MOV C,DATA_ADC1		;odczyt danych z ADC1.1
	MOV ACC.1,C
	MOV U1_L,A
	MOV A,U2_L
	MOV C,DATA_ADC2		;odczyt danych z ADC2.1
	CPL C
	MOV ACC.1,C
	MOV U2_L,A
	;***************************************************
	ACALL TIMER_CLK_L
	;***************************************************
	ACALL TIMER_CLK_H
	;**************************************************
	MOV A,U1_L
	MOV C,DATA_ADC1		;odczyt danych z ADC1.0
	MOV ACC.0,C
	MOV U1_L,A
	MOV A,U2_L
	MOV C,DATA_ADC2		;odczyt danych z ADC2.0
	CPL C
	MOV ACC.0,C
	MOV U2_L,A
;	przesylanie danych I
	;***************************************************
	ACALL TIMER_CLK_L
	;***************************************************
	ACALL TIMER_CLK_H
	;**************************************************
	MOV A,I1_H
	MOV C,DATA_ADC1		;odczyt danych z ADC1.7
	MOV ACC.7,C
	MOV I1_H,A
	MOV A,I2_H
	MOV C,DATA_ADC2		;odczyt danych z ADC2.7
	CPL C
	MOV ACC.7,C
	MOV I2_H,A
	;***************************************************
	ACALL TIMER_CLK_L
	;***************************************************
	ACALL TIMER_CLK_H
	;**************************************************
	MOV A,I1_H
	MOV C,DATA_ADC1		;odczyt danych z ADC1.6
	MOV ACC.6,C
	MOV I1_H,A
	MOV A,I2_H
	MOV C,DATA_ADC2		;odczyt danych z ADC2.6
	CPL C
	MOV ACC.6,C
	MOV I2_H,A
	;***************************************************
	ACALL TIMER_CLK_L
	;***************************************************
	ACALL TIMER_CLK_H
	;**************************************************
	MOV A,I1_H
	MOV C,DATA_ADC1		;odczyt danych z ADC1.5
	MOV ACC.5,C
	MOV I1_H,A
	MOV A,I2_H
	MOV C,DATA_ADC2		;odczyt danych z ADC2.5
	CPL C
	MOV ACC.5,C
	MOV I2_H,A
	;***************************************************
	ACALL TIMER_CLK_L
	;***************************************************
	ACALL TIMER_CLK_H
	;**************************************************
	MOV A,I1_H
	MOV C,DATA_ADC1		;odczyt danych z ADC1.4
	MOV ACC.4,C
	MOV I1_H,A
	MOV A,I2_H
	MOV C,DATA_ADC2		;odczyt danych z ADC2.4
	CPL C
	MOV ACC.4,C
	MOV I2_H,A
	;***************************************************
	ACALL TIMER_CLK_L
	;***************************************************
	ACALL TIMER_CLK_H
	;**************************************************
	MOV A,I1_H
	MOV C,DATA_ADC1		;odczyt danych z ADC1.3
	MOV ACC.3,C
	MOV I1_H,A
	MOV A,I2_H
	MOV C,DATA_ADC2		;odczyt danych z ADC2.3
	CPL C
	MOV ACC.3,C
	MOV I2_H,A
	;***************************************************
	ACALL TIMER_CLK_L
	;***************************************************
	ACALL TIMER_CLK_H
	;**************************************************
	MOV A,I1_H
	MOV C,DATA_ADC1		;odczyt danych z ADC1.2
	MOV ACC.2,C
	MOV I1_H,A
	MOV A,I2_H
	MOV C,DATA_ADC2		;odczyt danych z ADC2.2
	CPL C
	MOV ACC.2,C
	MOV I2_H,A
	;***************************************************
	ACALL TIMER_CLK_L
	;***************************************************
	ACALL TIMER_CLK_H
	;**************************************************
	MOV A,I1_H
	MOV C,DATA_ADC1		;odczyt danych z ADC1.1
	MOV ACC.1,C
	MOV I1_H,A
	MOV A,I2_H
	MOV C,DATA_ADC2		;odczyt danych z ADC2.1
	CPL C
	MOV ACC.1,C
	MOV I2_H,A
	;***************************************************
	ACALL TIMER_CLK_L
	;***************************************************
	ACALL TIMER_CLK_H
	;**************************************************
	MOV A,I1_H
	MOV C,DATA_ADC1		;odczyt danych z ADC1.0
	MOV ACC.0,C
	MOV I1_H,A
	MOV A,I2_H
	MOV C,DATA_ADC2		;odczyt danych z ADC2.0
	CPL C
	MOV ACC.0,C
	MOV I2_H,A
	;***************************************************
	ACALL TIMER_CLK_L
	;***************************************************
	ACALL TIMER_CLK_H
	;**************************************************
	MOV A,I1_L
	MOV C,DATA_ADC1		;odczyt danych z ADC1.3
	MOV ACC.3,C
	MOV I1_L,A
	MOV A,I2_L
	MOV C,DATA_ADC2		;odczyt danych z ADC2.3
	CPL C
	MOV ACC.3,C
	MOV I2_L,A
	;***************************************************
	ACALL TIMER_CLK_L
	;***************************************************
	ACALL TIMER_CLK_H
	;**************************************************
	MOV A,I1_L
	MOV C,DATA_ADC1		;odczyt danych z ADC1.2
	MOV ACC.2,C
	MOV I1_L,A
	MOV A,I2_L
	MOV C,DATA_ADC2		;odczyt danych z ADC2.2
	CPL C
	MOV ACC.2,C
	MOV I2_L,A
	;***************************************************
	ACALL TIMER_CLK_L
	;***************************************************
	ACALL TIMER_CLK_H
	;**************************************************
	MOV A,I1_L
	MOV C,DATA_ADC1		;odczyt danych z ADC1.1
	MOV ACC.1,C
	MOV I1_L,A
	MOV A,I2_L
	MOV C,DATA_ADC2		;odczyt danych z ADC2.1
	CPL C
	MOV ACC.1,C
	MOV I2_L,A
	;***************************************************
	ACALL TIMER_CLK_L
	;***************************************************
	ACALL TIMER_CLK_H
	;**************************************************
	MOV A,I1_L
	MOV C,DATA_ADC1		;odczyt danych z ADC1.0
	MOV ACC.0,C
	MOV I1_L,A
	MOV A,I2_L
	MOV C,DATA_ADC2		;odczyt danych z ADC2.0
	CPL C
	MOV ACC.0,C
	MOV I2_L,A
TIMER0:
	MOV A,#LINE2_LCD
	LCALL LCD
	MOV A,#SHIFT_CURSORR
	LCALL LCD
	LCALL LCD
	LCALL LCD
	MOV A,U1_H
	SWAP A
	ANL A,#0FH
	JNZ TIMER1
	MOV A,#' '
	SJMP TIMER1A
TIMER1:
	ORL A,#030H
TIMER1A:
	LCALL WRITE_LCD
	MOV A,U1_H
	ANL A,#0FH
	ORL A,#030H
	LCALL WRITE_LCD
	MOV A,#SHIFT_CURSORR
	LCALL LCD
	MOV A,U1_L
	ANL A,#0FH
	ORL A,#030H
	LCALL WRITE_LCD
	MOV A,#SHIFT_CURSORR
	LCALL LCD
	LCALL LCD
	LCALL LCD
	LCALL LCD
	LCALL LCD
	LCALL LCD
	LCALL LCD
	MOV A,U2_H
	SWAP A
	ANL A,#0FH
	JNZ TIMER2
	MOV A,#' '
	SJMP TIMER2A
TIMER2:
	ORL A,#030H
TIMER2A:
	LCALL WRITE_LCD
	MOV A,U2_H
	ANL A,#0FH
	ORL A,#030H
	LCALL WRITE_LCD
	MOV A,#SHIFT_CURSORR
	LCALL LCD
	MOV A,U2_L
	ANL A,#0FH
	ORL A,#030H
	LCALL WRITE_LCD
;wyswietlanie pradu	
	MOV A,#LINE3_LCD
	LCALL LCD
	MOV A,#SHIFT_CURSORR
	LCALL LCD
	LCALL LCD
	LCALL LCD
	MOV A,I1_H
	SWAP A
	ANL A,#0FH
	ORL A,#030H
	LCALL WRITE_LCD
	MOV A,#SHIFT_CURSORR
	LCALL LCD
	MOV A,I1_H
	ANL A,#0FH
	ORL A,#030H
	LCALL WRITE_LCD
	MOV A,I1_L
	ANL A,#0FH
	ORL A,#030H
	LCALL WRITE_LCD
	MOV A,#SHIFT_CURSORR
	LCALL LCD
	LCALL LCD
	LCALL LCD
	LCALL LCD
	LCALL LCD
	LCALL LCD
	LCALL LCD
	MOV A,I2_H
	SWAP A
	ANL A,#0FH
	ORL A,#030H
	LCALL WRITE_LCD
	MOV A,#SHIFT_CURSORR
	LCALL LCD
	MOV A,I2_H
	ANL A,#0FH
	ORL A,#030H
	LCALL WRITE_LCD
	MOV A,I2_L
	ANL A,#0FH
	ORL A,#030H
	LCALL WRITE_LCD
;	SETB P2.3
	POP PSW
	SETB TR0
	RET
;wymoszenie stanu niskiego na CLK
TIMER_CLK_L:
	CLR CLK	
	MOV A,#DELAY_CLK1	
	DJNZ ACC,$	
	RET
;wymuszenie stanu wysokiego na clk
TIMER_CLK_H:
	SETB CLK
	MOV A,#DELAY_CLK1		;ustabilizowanie poziomu H na clk
	DJNZ ACC,$	
	RET
;********************************************
DISPLAY_MODE:
	PUSH ACC
	PUSH B
	PUSH PSW
	CLR TR0
	MOV A,#LINE1_LCD
	LCALL LCD
;	MOV LINE,#LINE1_LCD
	MOV CURSOR_COUNT,#01H
	MOV B,#04H
	MOV A,#SHIFT_CURSORR
DISPLAY_MODE1A:
	LCALL LCD
	INC CURSOR_COUNT
	DJNZ B,DISPLAY_MODE1A
	MOV A,#00H
DISPLAY_MODE1B:
	PUSH ACC
	MOVC A,@A+DPTR
	LCALL WRITE_LCD
	INC CURSOR_COUNT
	POP ACC
	INC A
	CJNE A,#11,DISPLAY_MODE1B
	SETB TR0
	POP PSW
	POP B
	POP ACC
	RET
;funkcja dekrementacji w kodzie BCD
DEC_BCD:
	PUSH PSW
	PUSH ACC
	ANL A,#0FH
	JZ DEC_BCD1
	POP ACC
	DEC A
	SJMP DEC_BCD_END
DEC_BCD1:
	POP ACC
	SWAP A
	ANL A,#0FH
	DEC A
	SWAP A
	ORL A,#09H
DEC_BCD_END:
	POP PSW
	RET
;funkcja zapisu danych z pam eeprom do zasilaczy i na lcd
DATA:
	LCALL READ_MEM
	MOV PAM1,A		;!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
	ACALL CH_MODE
	INC R0
	LCALL U_MEM
	RET
;odczyt z eepromtrybu pracy
CH_MODE:
	PUSH DPL
	PUSH DPH
	PUSH B
	CJNE A,#'N',CH_MODE1
	MOV DPTR,#TAB_N
	SETB PX_1
	LCALL DELAY10
	CLR PX_2
	SJMP CH_MODE4
CH_MODE1:
	CJNE A,#'S',CH_MODE2
	MOV DPTR,#TAB_S
	SETB PX_1;	bylo 2
	LCALL DELAY10
	SETB PX_2; bylo 1
	SJMP CH_MODE4
CH_MODE2:
	CJNE A,#'R',CH_MODE3
	MOV DPTR,#TAB_R
	CLR PX_2	;bylo 1
	LCALL DELAY10
	CLR PX_1;	bylo 2	;BYLO SETB
	SJMP CH_MODE4
CH_MODE3:
	MOV DPTR,#TAB_ERROR1
	CLR PX_2
	SETB PX_1
CH_MODE4:
	LCALL DISPLAY_MODE
	POP B
	POP DPH
	POP DPL	
	RET
;odczyt z eeprom danych dotyczacych napiecia i pradu
;i wyslanie ich na zasilacze
U_MEM:
	PUSH PSW
	PUSH DPH
	PUSH DPL
	PUSH B
	MOV B,#0FFH
	LCALL READ_MEM ;U1 Z TABELI TAB_U2 (JESLI FF-WTEDY TAB_U1)
	MOV PAM2,A		;!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
	CJNE A,#0FFH,U_MEM1
	INC R0
	LCALL READ_MEM ;U1 Z TABELI TAB_U1
	MOV PAM3,A		;!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
	MOV MEM1,A ;	 pamiec ram U1
	SJMP U_MEM2
U_MEM1:
	MOV B,#0FEH
	MOV MEM1,A ; pamiec ram U1
	INC R0
U_MEM2:
	INC R0
	LCALL READ_MEM	 ;I1-MAX
	MOV PAM4,A		;!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
	XCH A,B
	MOV C,ACC.0
	XCH A,B
	MOV ACC.0,C
	MOV MEM12,A		;pamiec ram I1
	INC R0
	MOV B,#0FFH
	LCALL READ_MEM ;U2 Z TABELI TAB_U2 (JESLI FF-WTEDY TAB_U1)
	MOV PAM5,A		;!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
	CJNE A,#0FFH,U_MEM3
	INC R0
	LCALL READ_MEM ;U2 Z TABELI TAB_U1
	MOV PAM6,A		;!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
	MOV MEM2,A ;	 pamiec ram U2
	SJMP U_MEM4
U_MEM3:
	MOV B,#0FEH
	MOV MEM2,A ; pamiec ram U2
	INC R0
U_MEM4:
	INC R0
	LCALL READ_MEM	 ;I2-MAX
	MOV PAM7,A		;!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
	XCH A,B
	MOV C,ACC.0
	XCH A,B
	MOV ACC.0,C
	MOV MEM22,A		;pamiec ram I2
	CLR TR0
	MOV A,#LINE4_LCD
	LCALL LCD
;	MOV LINE,#LINE4_LCD
	MOV CURSOR_COUNT,#01H
	MOV B,#05H
U_MEM4A:
	MOV A,#SHIFT_CURSORR
	LCALL LCD
	INC CURSOR_COUNT
	DJNZ B,U_MEM4A
	SETB TR0
	MOV A,MEM12
	ORL A,#01H
	CJNE A,#00011111B,U_MEM5A; 0,1A
	MOV A,#00H
	SJMP U_MEM6
U_MEM5A:
	CJNE A,#10011111B,U_MEM5B;	0,2A
	MOV A,#03H
	SJMP U_MEM6
U_MEM5B:
	CJNE A,#01011111B,U_MEM5C;	0,3A
	MOV A,#06H
	SJMP U_MEM6
U_MEM5C:
	CJNE A,#11011111B,U_MEM5D;	0,5A
	MOV A,#09H
	SJMP U_MEM6
U_MEM5D:
	CJNE A,#00111111B,U_MEM5E;	0,8A
	MOV A,#12
	SJMP U_MEM6
U_MEM5E:
	CJNE A,#10111111B,U_MEM5F;	1,0A
	MOV A,#15
	SJMP U_MEM6
U_MEM5F:
	CJNE A,#01111111B,U_MEM5G;	2,0A
	MOV A,#18
	SJMP U_MEM6
U_MEM5G:
	CJNE A,#0FFH,U_MEM5H;	3,0A
	MOV A,#21
	SJMP U_MEM6
U_MEM5H:
	MOV A,#24
U_MEM6:
	MOV DPTR,#TAB_SERV2
	CLR TR0
	PUSH ACC
	MOVC A,@A+DPTR
	LCALL WRITE_LCD
	INC CURSOR_COUNT
	MOV A,#SHIFT_CURSORR
	LCALL LCD
	INC CURSOR_COUNT
	POP ACC
	INC A
	INC A
	MOVC A,@A+DPTR
	LCALL WRITE_LCD
	INC CURSOR_COUNT
	MOV B,#08H
U_MEM6A1:
	MOV A,#SHIFT_CURSORR
	LCALL LCD
	INC CURSOR_COUNT
	DJNZ B,U_MEM6A1
	SETB TR0
	MOV A,MEM22
	ORL A,#01H
	CJNE A,#00011111B,U_MEM6A; 0,1A
	MOV A,#00H
	SJMP U_MEM7
U_MEM6A:
	CJNE A,#10011111B,U_MEM6B;	0,2A
	MOV A,#03H
	SJMP U_MEM7
U_MEM6B:
	CJNE A,#01011111B,U_MEM6C;	0,3A
	MOV A,#06H
	SJMP U_MEM7
U_MEM6C:
	CJNE A,#11011111B,U_MEM6D;	0,5A
	MOV A,#09H
	SJMP U_MEM7
U_MEM6D:
	CJNE A,#00111111B,U_MEM6E;	0,8A
	MOV A,#12
	SJMP U_MEM7
U_MEM6E:
	CJNE A,#10111111B,U_MEM6F;	1,0A
	MOV A,#15
	SJMP U_MEM7
U_MEM6F:
	CJNE A,#01111111B,U_MEM6G;	2,0A
	MOV A,#18
	SJMP U_MEM7
U_MEM6G:
	CJNE A,#0FFH,U_MEM6H;	3,0A
	MOV A,#21
	SJMP U_MEM7
U_MEM6H:
	MOV A,#24
U_MEM7:
	MOV DPTR,#TAB_SERV2
	CLR TR0
	PUSH ACC
	MOVC A,@A+DPTR
	LCALL WRITE_LCD
	INC CURSOR_COUNT
	MOV A,#SHIFT_CURSORR
	LCALL LCD
	INC CURSOR_COUNT
	POP ACC
	INC A
	INC A
	MOVC A,@A+DPTR
	LCALL WRITE_LCD
	INC CURSOR_COUNT
	SETB TR0
	MOV A,MEM1
	MOV B,MEM12
	LCALL SEND1
	MOV A,MEM2
	MOV B,MEM22
	LCALL SEND2
	POP B
	POP DPL
	POP DPH
	POP PSW
	RET
;odczyt klawiatury
;key:= 0 - brak klawisza
; up, down, enter
RD_KEY:
	CLR EA
	PUSH PSW
	MOV KEY,#00H
	MOV C,KEY_ENTER
	JC RD_KEY1
	MOV KEY,#01H
	SJMP KEY_RD_END
RD_KEY1:
	MOV C,KEY_UP
	JC RD_KEY2
	MOV KEY,#UP
	SJMP KEY_RD_END
RD_KEY2:
	MOV C,KEY_DOWN
	JC RD_KEY1
	MOV KEY,#DOWN
KEY_RD_END:
	LCALL DELAY10
	MOV C,P3.2
	JNC KEY_RD_END
	SETB EA
	POP PSW
	RET
;procedura ustawienia trybu pracy matrycy LCD 8bit
; P1: D7 - D0
INIT_LCD:
	LCALL DELAY10 ;opoznienie 10ms
	LCALL DELAY10 ;opoznienie 10ms
	LCALL DELAY10 ;opoznienie 10ms
	LCALL DELAY10 ;opoznienie 10ms
	LCALL DELAY10 ;opoznienie 10ms
	CLR E_LCD ;
	CLR RS_LCD
	CLR RW_LCD
	MOV DB_LCD,#00111111B ;function set 1
	SETB E_LCD
	CLR E_LCD
	LCALL DELAY10 ;opoznienie 10ms
	MOV DB_LCD,#00111111B ;function set 2
	SETB E_LCD
	CLR E_LCD
	MOV A,#080H
	DJNZ ACC,$ ; opoznienie 0,255ms
	MOV DB_LCD,#00111111B ;function set 3	
	SETB E_LCD
	CLR E_LCD
	MOV A,#080H
	DJNZ ACC,$ ; opoznienie 0,255ms
	MOV DB_LCD,#00111111B ;function set 4
	SETB E_LCD
	CLR E_LCD
	LCALL BUSY_LCD
	MOV DB_LCD,#00001000B ;display off
	SETB E_LCD
	CLR E_LCD
	LCALL BUSY_LCD
	MOV DB_LCD,#00000001B ; display clr
	SETB E_LCD
	CLR E_LCD
	LCALL BUSY_LCD
	MOV DB_LCD,#00000110B ; entry mode set
	SETB E_LCD
	CLR E_LCD
	LCALL BUSY_LCD
	MOV DB_LCD,#0CH ; display on
	SETB E_LCD
	CLR E_LCD
	LCALL BUSY_LCD
	MOV DB_LCD,#06H; entry mode set
	SETB E_LCD
	CLR E_LCD
	LCALL BUSY_LCD
	RET
;procedura sprawdzania flagi zajentosci matrycy LCD
BUSY_LCD:
	PUSH DB_LCD
	PUSH P2
	CLR E_LCD
	CLR RS_LCD
	SETB RW_LCD
	MOV DB_LCD,#0FFH
BUSY_LCD0:
	SETB E_LCD
	MOV C,BB_LCD
	CLR E_LCD
	JC BUSY_LCD0
	POP P2
	POP DB_LCD
	RET
;procedura zapisu znaku do matrycy LCD z acc
WRITE_LCD:
	PUSH DB_LCD
	PUSH P2
	CLR E_LCD
	SETB RS_LCD
	CLR RW_LCD
	MOV DB_LCD,A
	SETB E_LCD
	CLR E_LCD
	LCALL BUSY_LCD 
	POP P2
	POP DB_LCD
	RET
; procedura obslugi matrycy Lcd
LCD:
	PUSH DB_LCD
	PUSH P2
	CLR E_LCD
	CLR RS_LCD
	CLR RW_LCD
	MOV DB_LCD,A
	SETB E_LCD
	CLR E_LCD
	LCALL BUSY_LCD
	POP P2
	POP DB_LCD
	RET
;procedura napisu wizytowki
IDENT:
	PUSH DPH
	PUSH DPL
	MOV DPTR,#TABIDENT	
	ACALL MONITOR; zapis czlowki
	POP DPL
	POP DPH
	MOV A,#0FFH
IDENT1:
	LCALL DELAY10; opoz. o 2,55s
	DJNZ ACC,IDENT1
	RET 
;zapis planszy menu
MONITOR:
	PUSH PSW
	;CLR TR0
	MOV A,#CLR_LCD
	LCALL LCD
	MOV A,#00H
	MOV R7,#00H
MONIT1:
	PUSH ACC
	MOVC A,@A+DPTR ; adres w tabeli znakow
	LCALL WRITE_LCD; zapis czlowki
	POP ACC
	INC R7
	INC A
	CJNE R7,#20,MONIT1
	PUSH ACC
	MOV A,#LINE2_LCD
	LCALL LCD
;	MOV LINE,#LINE2_LCD
	POP ACC
	MOV R7,#00H
MONIT2:
	PUSH ACC
	MOVC A,@A+DPTR ; adres w tabeli znakow
	LCALL WRITE_LCD; zapis czlowki
	POP ACC
	INC R7
	INC A
	CJNE R7,#20,MONIT2
	PUSH ACC
	MOV A,#LINE3_LCD
	LCALL LCD
;	MOV LINE,#LINE3_LCD
	POP ACC
	MOV R7,#00H
MONIT3:
	PUSH ACC
	MOVC A,@A+DPTR ; adres w tabeli znakow
	LCALL WRITE_LCD; zapis czlowki
	POP ACC
	INC R7
	INC A
	CJNE R7,#20,MONIT3
	PUSH ACC
	MOV A,#LINE4_LCD
	LCALL LCD
;	MOV LINE,#LINE4_LCD
	POP ACC
	MOV R7,#00H
MONIT4:
	PUSH ACC
	MOVC A,@A+DPTR ; adres w tabeli znakow
	LCALL WRITE_LCD; zapis czlowki
	POP ACC
	INC R7
	INC A
	CJNE R7,#20,MONIT4
MONIT_END:
	;SETB TR0
	POP PSW
	RET
; procedura realizujaca opoznienie o 200 ms
DELAY200:
	PUSH ACC
	MOV A,#020
DELAY201:
	LCALL DELAY10
	DJNZ ACC,DELAY201
	POP ACC
	RET
;opoznienie o 10ms
DELAY10:
	PUSH DPH ; 2
	PUSH DPL ; 2
	PUSH ACC ; 2
	MOV DPH,#0F8H ; 1 1111 1000 zaladoane 56336 cykli
	MOV DPL,#033H ; 1 0011 0011
DEL11:
	INC DPTR ; 2       a
	MOV A,DPH ; 1
	JNZ DEL11 ; 2      b
	POP ACC ; 2
	POP DPL ; 2
	POP DPH ; 2
	RET ; 2
; procedura realizujaca opoznienie o 200 ms
DELAY1s:
	PUSH ACC
	MOV A,#05
DELAY1s1:
	LCALL DELAY200
	DJNZ ACC,DELAY1s1
	POP ACC
	RET
; procedura pobrania danych z ADC0831
ADC:
	RET
;wysyanie danych do zasilacza nr1
; B - MSB, A - LSB  - NAPIECIE
SEND1:
	CLR EA
	PUSH PSW
	CLR CLK
	CLR STROBE1
	XCH A,B
	RLC A
	MOV DATA_OUT1,C	; B.7
	SETB CLK
	NOP
	CLR CLK
	NOP
	RLC A
	MOV DATA_OUT1,C	; B.6
	SETB CLK
	NOP
	CLR CLK
	NOP
	RLC A
	MOV DATA_OUT1,C	; B.5
	SETB CLK
	NOP
	CLR CLK
	NOP
	RLC A
	MOV DATA_OUT1,C	; B.4
	SETB CLK
	NOP
	CLR CLK
	NOP
	RLC A
	MOV DATA_OUT1,C	; B.3
	SETB CLK
	NOP
	CLR CLK
	NOP
	RLC A
	MOV DATA_OUT1,C	; B.2
	SETB CLK
	NOP
	CLR CLK
	NOP
	RLC A
	MOV DATA_OUT1,C	; B.1
	SETB CLK
	NOP
	CLR CLK
	NOP
	RLC A
	MOV DATA_OUT1,C	; B.0
	SETB CLK
	NOP
	CLR CLK
	NOP
	MOV A,B
	CLR C;!!!!!!!!!!!!!!!!!!!!!!!!!
	RLC A
	MOV DATA_OUT1,C	; A.7
	SETB CLK
	NOP
	CLR CLK
	NOP
	RLC A
	MOV DATA_OUT1,C	; A.6
	SETB CLK
	NOP
	CLR CLK
	NOP
	RLC A
	MOV DATA_OUT1,C	; A.5
	SETB CLK
	NOP
	CLR CLK
	NOP
	RLC A
	MOV DATA_OUT1,C	; A.4
	SETB CLK
	NOP
	CLR CLK
	NOP
	RLC A
	MOV DATA_OUT1,C	; A.3
	SETB CLK
	NOP
	CLR CLK
	NOP
	RLC A
	MOV DATA_OUT1,C	; A.2
	SETB CLK
	NOP
	CLR CLK
	NOP
	RLC A
	MOV DATA_OUT1,C	; A.1
	SETB CLK
	NOP
	CLR CLK
	NOP
	RLC A
	MOV DATA_OUT1,C	; A.0
	SETB CLK
	NOP
	CLR CLK
	NOP
	SETB STROBE1
	NOP
	CLR STROBE1
	SETB CLK
	SETB DATA_OUT1
	POP PSW
	SETB EA
	RET
;*********************************************
;wysyanie danych do zasilacza nr2 (transoptor)
; B - MSB, A - LSB  - NAPIECIE
SEND2:
	CLR EA
	PUSH PSW
	CLR CLK
	PUSH ACC	;!!!!!!!!!!!!
	MOV A,#DELAY_CLK1	;!!!!!!!!!!!!
	DJNZ ACC,$	;!!!!!!!!!!!!
	POP ACC	;!!!!!!!!!!!!
	CLR STROBE2
	XCH A,B
	RLC A
	MOV DATA_OUT2,C	; B.7
	PUSH ACC	;!!!!!!!!!!!!
	MOV A,#DELAY_CLK1	;!!!!!!!!!!!!
	DJNZ ACC,$	;!!!!!!!!!!!!
	POP ACC	;!!!!!!!!!!!!
	SETB CLK
	;NOP
	PUSH ACC	;!!!!!!!!!!!!
	MOV A,#DELAY_CLK1	;!!!!!!!!!!!!
	DJNZ ACC,$	;!!!!!!!!!!!!
	POP ACC	;!!!!!!!!!!!!
	CLR CLK
	;NOP
	;NOP
	PUSH ACC	;!!!!!!!!!!!!
	MOV A,#DELAY_CLK1	;!!!!!!!!!!!!
	DJNZ ACC,$	;!!!!!!!!!!!!
	POP ACC	;!!!!!!!!!!!!
	RLC A
	MOV DATA_OUT2,C	; B.6
	PUSH ACC	;!!!!!!!!!!!!
	MOV A,#DELAY_CLK1	;!!!!!!!!!!!!
	DJNZ ACC,$	;!!!!!!!!!!!!
	POP ACC	;!!!!!!!!!!!!
	SETB CLK
	;NOP
	PUSH ACC	;!!!!!!!!!!!!
	MOV A,#DELAY_CLK1	;!!!!!!!!!!!!
	DJNZ ACC,$	;!!!!!!!!!!!!
	POP ACC	;!!!!!!!!!!!!
	CLR CLK
	;NOP
	;NOP
	PUSH ACC	;!!!!!!!!!!!!
	MOV A,#DELAY_CLK1	;!!!!!!!!!!!!
	DJNZ ACC,$	;!!!!!!!!!!!!
	POP ACC	;!!!!!!!!!!!!
	RLC A
	MOV DATA_OUT2,C	; B.5
	PUSH ACC	;!!!!!!!!!!!!
	MOV A,#DELAY_CLK1	;!!!!!!!!!!!!
	DJNZ ACC,$	;!!!!!!!!!!!!
	POP ACC	;!!!!!!!!!!!!
	SETB CLK
	;NOP
	PUSH ACC	;!!!!!!!!!!!!
	MOV A,#DELAY_CLK1	;!!!!!!!!!!!!
	DJNZ ACC,$	;!!!!!!!!!!!!
	POP ACC	;!!!!!!!!!!!!
	CLR CLK
	PUSH ACC	;!!!!!!!!!!!!
	MOV A,#DELAY_CLK1	;!!!!!!!!!!!!
	DJNZ ACC,$	;!!!!!!!!!!!!
	POP ACC	;!!!!!!!!!!!!
	RLC A
	MOV DATA_OUT2,C	; B.4
	PUSH ACC	;!!!!!!!!!!!!
	MOV A,#DELAY_CLK1	;!!!!!!!!!!!!
	DJNZ ACC,$	;!!!!!!!!!!!!
	POP ACC	;!!!!!!!!!!!!
	SETB CLK
	;NOP
	PUSH ACC	;!!!!!!!!!!!!
	MOV A,#DELAY_CLK1	;!!!!!!!!!!!!
	DJNZ ACC,$	;!!!!!!!!!!!!
	POP ACC	;!!!!!!!!!!!!
	CLR CLK
;	NOP
;	NOP
	PUSH ACC	;!!!!!!!!!!!!
	MOV A,#DELAY_CLK1	;!!!!!!!!!!!!
	DJNZ ACC,$	;!!!!!!!!!!!!
	POP ACC	;!!!!!!!!!!!!
	RLC A
	MOV DATA_OUT2,C	; B.3
	PUSH ACC	;!!!!!!!!!!!!
	MOV A,#DELAY_CLK1	;!!!!!!!!!!!!
	DJNZ ACC,$	;!!!!!!!!!!!!
	POP ACC
	SETB CLK
	;NOP
	PUSH ACC	;!!!!!!!!!!!!
	MOV A,#DELAY_CLK1	;!!!!!!!!!!!!
	DJNZ ACC,$	;!!!!!!!!!!!!
	POP ACC	;!!!!!!!!!!!!
	CLR CLK
;	NOP
;	NOP
	PUSH ACC	;!!!!!!!!!!!!
	MOV A,#DELAY_CLK1	;!!!!!!!!!!!!
	DJNZ ACC,$	;!!!!!!!!!!!!
	POP ACC	;!!!!!!!!!!!!
	RLC A
	MOV DATA_OUT2,C	; B.2
	PUSH ACC	;!!!!!!!!!!!!
	MOV A,#DELAY_CLK1	;!!!!!!!!!!!!
	DJNZ ACC,$	;!!!!!!!!!!!!
	POP ACC	;!!!!!!!!!!!!
	SETB CLK
	;NOP
	PUSH ACC	;!!!!!!!!!!!!
	MOV A,#DELAY_CLK1	;!!!!!!!!!!!!
	DJNZ ACC,$	;!!!!!!!!!!!!
	POP ACC	;!!!!!!!!!!!!
	CLR CLK
;	NOP
;	NOP
	PUSH ACC	;!!!!!!!!!!!!
	MOV A,#DELAY_CLK1	;!!!!!!!!!!!!
	DJNZ ACC,$	;!!!!!!!!!!!!
	POP ACC	;!!!!!!!!!!!!
	RLC A
	MOV DATA_OUT2,C	; B.1
	PUSH ACC	;!!!!!!!!!!!!
	MOV A,#DELAY_CLK1	;!!!!!!!!!!!!
	DJNZ ACC,$	;!!!!!!!!!!!!
	POP ACC	;!!!!!!!!!!!!
	SETB CLK
	;NOP
	PUSH ACC	;!!!!!!!!!!!!
	MOV A,#DELAY_CLK1	;!!!!!!!!!!!!
	DJNZ ACC,$	;!!!!!!!!!!!!
	POP ACC	;!!!!!!!!!!!!
	CLR CLK
;	NOP
;	NOP
	PUSH ACC	;!!!!!!!!!!!!
	MOV A,#DELAY_CLK1	;!!!!!!!!!!!!
	DJNZ ACC,$	;!!!!!!!!!!!!
	POP ACC	;!!!!!!!!!!!!
	RLC A
	MOV DATA_OUT2,C	; B.0
	PUSH ACC	;!!!!!!!!!!!!
	MOV A,#DELAY_CLK1	;!!!!!!!!!!!!
	DJNZ ACC,$	;!!!!!!!!!!!!
	POP ACC	;!!!!!!!!!!!!
	SETB CLK
	;NOP
	PUSH ACC	;!!!!!!!!!!!!
	MOV A,#DELAY_CLK1	;!!!!!!!!!!!!
	DJNZ ACC,$	;!!!!!!!!!!!!
	POP ACC	;!!!!!!!!!!!!
	CLR CLK
;	NOP
;	NOP
	PUSH ACC	;!!!!!!!!!!!!
	MOV A,#DELAY_CLK1	;!!!!!!!!!!!!
	DJNZ ACC,$	;!!!!!!!!!!!!
	POP ACC	;!!!!!!!!!!!!
	PUSH ACC	;!!!!!!!!!!!!
	MOV A,#DELAY_CLK1	;!!!!!!!!!!!!
	DJNZ ACC,$	;!!!!!!!!!!!!
	POP ACC	;!!!!!!!!!!!!
	MOV A,B
	RLC A
	MOV DATA_OUT2,C	; A.7
	PUSH ACC	;!!!!!!!!!!!!
	MOV A,#DELAY_CLK1	;!!!!!!!!!!!!
	DJNZ ACC,$	;!!!!!!!!!!!!
	POP ACC	;!!!!!!!!!!!!
	SETB CLK
	PUSH ACC	;!!!!!!!!!!!!
	MOV A,#DELAY_CLK1	;!!!!!!!!!!!!
	DJNZ ACC,$	;!!!!!!!!!!!!
	POP ACC	;!!!!!!!!!!!!
	;NOP
	CLR CLK
;	NOP
;	NOP
	PUSH ACC	;!!!!!!!!!!!!
	MOV A,#DELAY_CLK1	;!!!!!!!!!!!!
	DJNZ ACC,$	;!!!!!!!!!!!!
	POP ACC	;!!!!!!!!!!!!
	RLC A
	MOV DATA_OUT2,C	; A.6
	PUSH ACC	;!!!!!!!!!!!!
	MOV A,#DELAY_CLK1	;!!!!!!!!!!!!
	DJNZ ACC,$	;!!!!!!!!!!!!
	POP ACC	;!!!!!!!!!!!!
	SETB CLK
	;NOP
	PUSH ACC	;!!!!!!!!!!!!
	MOV A,#DELAY_CLK1	;!!!!!!!!!!!!
	DJNZ ACC,$	;!!!!!!!!!!!!
	POP ACC	;!!!!!!!!!!!!
	CLR CLK
;	NOP
;	NOP
	PUSH ACC	;!!!!!!!!!!!!
	MOV A,#DELAY_CLK1	;!!!!!!!!!!!!
	DJNZ ACC,$	;!!!!!!!!!!!!
	POP ACC	;!!!!!!!!!!!!
	RLC A
	MOV DATA_OUT2,C	; A.5
	PUSH ACC	;!!!!!!!!!!!!
	MOV A,#DELAY_CLK1	;!!!!!!!!!!!!
	DJNZ ACC,$	;!!!!!!!!!!!!
	POP ACC	;!!!!!!!!!!!!
	SETB CLK
	;NOP
	PUSH ACC	;!!!!!!!!!!!!
	MOV A,#DELAY_CLK1	;!!!!!!!!!!!!
	DJNZ ACC,$	;!!!!!!!!!!!!
	POP ACC	;!!!!!!!!!!!!
	CLR CLK
;	NOP
;	NOP
	PUSH ACC	;!!!!!!!!!!!!
	MOV A,#DELAY_CLK1	;!!!!!!!!!!!!
	DJNZ ACC,$	;!!!!!!!!!!!!
	POP ACC	;!!!!!!!!!!!!
	RLC A
	MOV DATA_OUT2,C	; A.4
	PUSH ACC	;!!!!!!!!!!!!
	MOV A,#DELAY_CLK1	;!!!!!!!!!!!!
	DJNZ ACC,$	;!!!!!!!!!!!!
	POP ACC	;!!!!!!!!!!!!
	SETB CLK
	PUSH ACC	;!!!!!!!!!!!!
	MOV A,#DELAY_CLK1	;!!!!!!!!!!!!
	DJNZ ACC,$	;!!!!!!!!!!!!
	POP ACC	;!!!!!!!!!!!!
	;NOP
	CLR CLK
;	NOP
;	NOP
	PUSH ACC	;!!!!!!!!!!!!
	MOV A,#DELAY_CLK1	;!!!!!!!!!!!!
	DJNZ ACC,$	;!!!!!!!!!!!!
	POP ACC	;!!!!!!!!!!!!
	RLC A
	MOV DATA_OUT2,C	; A.3
	PUSH ACC	;!!!!!!!!!!!!
	MOV A,#DELAY_CLK1	;!!!!!!!!!!!!
	DJNZ ACC,$	;!!!!!!!!!!!!
	POP ACC	;!!!!!!!!!!!!
	SETB CLK
	PUSH ACC	;!!!!!!!!!!!!
	MOV A,#DELAY_CLK1	;!!!!!!!!!!!!
	DJNZ ACC,$	;!!!!!!!!!!!!
	POP ACC	;!!!!!!!!!!!!
	;NOP
	CLR CLK
;	NOP
;	NOP
	PUSH ACC	;!!!!!!!!!!!!
	MOV A,#DELAY_CLK1	;!!!!!!!!!!!!
	DJNZ ACC,$	;!!!!!!!!!!!!
	POP ACC	;!!!!!!!!!!!!
	RLC A
	MOV DATA_OUT2,C	; A.2
	PUSH ACC	;!!!!!!!!!!!!
	MOV A,#DELAY_CLK1	;!!!!!!!!!!!!
	DJNZ ACC,$	;!!!!!!!!!!!!
	POP ACC	;!!!!!!!!!!!!
	SETB CLK
	;NOP
	PUSH ACC	;!!!!!!!!!!!!
	MOV A,#DELAY_CLK1	;!!!!!!!!!!!!
	DJNZ ACC,$	;!!!!!!!!!!!!
	POP ACC	;!!!!!!!!!!!!
	CLR CLK
;	NOP
;	NOP
	PUSH ACC	;!!!!!!!!!!!!
	MOV A,#DELAY_CLK1	;!!!!!!!!!!!!
	DJNZ ACC,$	;!!!!!!!!!!!!
	POP ACC	;!!!!!!!!!!!!
	RLC A
	MOV DATA_OUT2,C	; A.1
	PUSH ACC	;!!!!!!!!!!!!
	MOV A,#DELAY_CLK1	;!!!!!!!!!!!!
	DJNZ ACC,$	;!!!!!!!!!!!!
	POP ACC	;!!!!!!!!!!!!
	SETB CLK
	;NOP
	PUSH ACC	;!!!!!!!!!!!!
	MOV A,#DELAY_CLK1	;!!!!!!!!!!!!
	DJNZ ACC,$	;!!!!!!!!!!!!
	POP ACC	;!!!!!!!!!!!!
	CLR CLK
;	NOP
;	NOP
	PUSH ACC	;!!!!!!!!!!!!
	MOV A,#DELAY_CLK1	;!!!!!!!!!!!!
	DJNZ ACC,$	;!!!!!!!!!!!!
	POP ACC	;!!!!!!!!!!!!
	RLC A
	MOV DATA_OUT2,C	; A.0
	PUSH ACC	;!!!!!!!!!!!!
	MOV A,#DELAY_CLK1	;!!!!!!!!!!!!
	DJNZ ACC,$	;!!!!!!!!!!!!
	POP ACC	;!!!!!!!!!!!!
	SETB CLK
	;NOP
	PUSH ACC	;!!!!!!!!!!!!
	MOV A,#DELAY_CLK1	;!!!!!!!!!!!!
	DJNZ ACC,$	;!!!!!!!!!!!!
	POP ACC	;!!!!!!!!!!!!
	CLR CLK
	;NOP
	PUSH ACC	;!!!!!!!!!!!!
	MOV A,#DELAY_CLK1	;!!!!!!!!!!!!
	DJNZ ACC,$	;!!!!!!!!!!!!
	POP ACC	;!!!!!!!!!!!!
	SETB STROBE2
;	NOP
	PUSH ACC	;!!!!!!!!!!!!
	MOV A,#DELAY_CLK1	;!!!!!!!!!!!!
	DJNZ ACC,$	;!!!!!!!!!!!!
	POP ACC	;!!!!!!!!!!!!
	CLR STROBE2
	PUSH ACC	;!!!!!!!!!!!!
	MOV A,#DELAY_CLK1	;!!!!!!!!!!!!
	DJNZ ACC,$	;!!!!!!!!!!!!
	POP ACC	;!!!!!!!!!!!!
	SETB CLK
	SETB DATA_OUT2
	POP PSW
	SETB EA
	RET
;*********************************************
;procedura odczytu bajtu z eeprom do ACC
; spod adresu adr_peage, r0
READ_MEM:
	CLR EA;!!!!!!!!!!!!!!
	SETB SCK
	SETB SDA
	LCALL DELAY_SCK
	CLR SDA
	LCALL DELAY_SCK
	CLR SCK
;adres strony
	MOV A,#00H;ADR_PEAGE
	CLR C
	RLC A
	ORL A,#11110000B
	ANL A,#10101111B
;ADR.7
	RLC A
	MOV SDA,C
	SETB SCK
	LCALL DELAY_SCK
	CLR SCK
;ADR.6
	RLC A
	MOV SDA,C
	SETB SCK
	LCALL DELAY_SCK
	CLR SCK
;ADR.5
	RLC A
	MOV SDA,C
	SETB SCK
	LCALL DELAY_SCK
	CLR SCK
;ADR.4
	RLC A
	MOV SDA,C
	SETB SCK
	LCALL DELAY_SCK
	CLR SCK
;ADR.3
	RLC A
	MOV SDA,C
	SETB SCK
	LCALL DELAY_SCK
	CLR SCK
;ADR.2
	RLC A
	MOV SDA,C
	SETB SCK
	LCALL DELAY_SCK
	CLR SCK
;ADR.1
	RLC A
	MOV SDA,C
	SETB SCK
	LCALL DELAY_SCK
	CLR SCK
;ADR.0
	RLC A
	MOV SDA,C
	SETB SCK
	LCALL DELAY_SCK
	CLR SCK
;test ack	
	SETB SDA
	SETB SCK
	LCALL DELAY_SCK
	MOV C,SDA
	JNC READ_MEM1
	LCALL DELAY_SCK
	MOV C,SDA
	JNC READ_MEM1
	LCALL DELAY_SCK
	MOV C,SDA
	JNC READ_MEM1
	LJMP READ_MEM
READ_MEM1:
	CLR SCK
;adres R0
	MOV A,R0
;R0.7
	RLC A
	MOV SDA,C
	SETB SCK
	LCALL DELAY_SCK
	CLR SCK
;R0.6
	RLC A
	MOV SDA,C
	SETB SCK
	LCALL DELAY_SCK
	CLR SCK
;R0.5
	RLC A
	MOV SDA,C
	SETB SCK
	LCALL DELAY_SCK
	CLR SCK
;R0.4
	RLC A
	MOV SDA,C
	SETB SCK
	LCALL DELAY_SCK
	CLR SCK
;R0.3
	RLC A
	MOV SDA,C
	SETB SCK
	LCALL DELAY_SCK
	CLR SCK
;R0.2
	RLC A
	MOV SDA,C
	SETB SCK
	LCALL DELAY_SCK
	CLR SCK
;R0.1
	RLC A
	MOV SDA,C
	SETB SCK
	LCALL DELAY_SCK
	CLR SCK
;R0.0
	RLC A
	MOV SDA,C
	SETB SCK
	LCALL DELAY_SCK
	CLR SCK
;test ack	
	SETB SDA
	SETB SCK
	LCALL DELAY_SCK
	MOV C,SDA
	JNC READ_MEM2
	LCALL DELAY_SCK
	MOV C,SDA
	JNC READ_MEM2
	LCALL DELAY_SCK
	MOV C,SDA
	JNC READ_MEM2
	LJMP READ_MEM
READ_MEM2:
	CLR SCK
;start2
	SETB SDA
	LCALL DELAY_SCK
	SETB SCK
	CLR SDA
	LCALL DELAY_SCK
	CLR SCK
	SETB SDA
;adres str (odczyt)
	MOV A,#00H;ADR_PEAGE
	SETB C
	RLC A
	ORL A,#11110000B
	ANL A,#10101111B
;ADR.7
	RLC A
	MOV SDA,C
	SETB SCK
	LCALL DELAY_SCK
	CLR SCK
;ADR.6
	RLC A
	MOV SDA,C
	SETB SCK
	LCALL DELAY_SCK
	CLR SCK
;ADR.5
	RLC A
	MOV SDA,C
	SETB SCK
	LCALL DELAY_SCK
	CLR SCK
;ADR.4
	RLC A
	MOV SDA,C
	SETB SCK
	LCALL DELAY_SCK
	CLR SCK
;ADR.3
	RLC A
	MOV SDA,C
	SETB SCK
	LCALL DELAY_SCK
	CLR SCK
;ADR.2
	RLC A
	MOV SDA,C
	SETB SCK
	LCALL DELAY_SCK
	CLR SCK
;ADR.1
	RLC A
	MOV SDA,C
	SETB SCK
	LCALL DELAY_SCK
	CLR SCK
;ADR.0
	RLC A
	MOV SDA,C
	SETB SCK
	LCALL DELAY_SCK
	CLR SCK
;test ack	
	SETB SDA
	SETB SCK
	LCALL DELAY_SCK
	MOV C,SDA
	JNC READ_MEM3
	LCALL DELAY_SCK
	MOV C,SDA
	JNC READ_MEM3
	LCALL DELAY_SCK
	MOV C,SDA
	JNC READ_MEM3
	LJMP READ_MEM
READ_MEM3:
	CLR SCK
;odbior danych
	SETB SDA
;D.7
	SETB SCK
	LCALL DELAY_SCK
	MOV C,SDA
	CLR SCK
	MOV ACC.7,C
;D.6
	SETB SCK
	LCALL DELAY_SCK
	MOV C,SDA
	CLR SCK
	MOV ACC.6,C
;D.5
	SETB SCK
	LCALL DELAY_SCK
	MOV C,SDA
	CLR SCK
	MOV ACC.5,C
;D.4
	SETB SCK
	LCALL DELAY_SCK
	MOV C,SDA
	CLR SCK
	MOV ACC.4,C
;D.3
	SETB SCK
	LCALL DELAY_SCK
	MOV C,SDA
	CLR SCK
	MOV ACC.3,C
;D.2
	SETB SCK
	LCALL DELAY_SCK
	MOV C,SDA
	CLR SCK
	MOV ACC.2,C
;D.1
	SETB SCK
	LCALL DELAY_SCK
	MOV C,SDA
	CLR SCK
	MOV ACC.1,C
;D.0
	SETB SCK
	LCALL DELAY_SCK
	MOV C,SDA
	CLR SCK
	MOV ACC.0,C
;STOP
	CLR SDA
	SETB SCK
	LCALL DELAY_SCK
	SETB SDA
	SETB EA;!!!!!!!!!!!!!!!!!
	RET
;*********************************************
;procedura zapisu bajtu z ACC do eeprom copy
; spod adresu adr_peage, r0
WRITE_MEM:
	CLR EA;!!!!!!!!!!!!!!!!!!
	PUSH ACC
WRITE_MEM0:
	SETB SCK
	SETB SDA
	LCALL DELAY_SCK
	CLR SDA
	LCALL DELAY_SCK
	CLR SCK
;adres strony
	MOV A,#00H;ADR_PEAGE
	CLR C
	RLC A
	ORL A,#11110000B
	ANL A,#10101110B
;ADR.7
	RLC A
	MOV SDA,C
	SETB SCK
	LCALL DELAY_SCK
	CLR SCK
;ADR.6
	RLC A
	MOV SDA,C
	SETB SCK
	LCALL DELAY_SCK
	CLR SCK
;ADR.5
	RLC A
	MOV SDA,C
	SETB SCK
	LCALL DELAY_SCK
	CLR SCK
;ADR.4
	RLC A
	MOV SDA,C
	SETB SCK
	LCALL DELAY_SCK
	CLR SCK
;ADR.3
	RLC A
	MOV SDA,C
	SETB SCK
	LCALL DELAY_SCK
	CLR SCK
;ADR.2
	RLC A
	MOV SDA,C
	SETB SCK
	LCALL DELAY_SCK
	CLR SCK
;ADR.1
	RLC A
	MOV SDA,C
	SETB SCK
	LCALL DELAY_SCK
	CLR SCK
;ADR.0
	RLC A
	MOV SDA,C
	SETB SCK
	LCALL DELAY_SCK
	CLR SCK
;test ack	
	SETB SDA
	SETB SCK
	LCALL DELAY_SCK
	MOV C,SDA
	JNC WRITE_MEM1
	LCALL DELAY_SCK
	MOV C,SDA
	JNC WRITE_MEM1
	LCALL DELAY_SCK
	MOV C,SDA
	JNC WRITE_MEM1
	LJMP WRITE_MEM0
WRITE_MEM1:
	CLR SCK
;adres R0
	MOV A,R0
;R0.7
	RLC A
	MOV SDA,C
	SETB SCK
	LCALL DELAY_SCK
	CLR SCK
;R0.6
	RLC A
	MOV SDA,C
	SETB SCK
	LCALL DELAY_SCK
	CLR SCK
;R0.5
	RLC A
	MOV SDA,C
	SETB SCK
	LCALL DELAY_SCK
	CLR SCK
;R0.4
	RLC A
	MOV SDA,C
	SETB SCK
	LCALL DELAY_SCK
	CLR SCK
;R0.3
	RLC A
	MOV SDA,C
	SETB SCK
	LCALL DELAY_SCK
	CLR SCK
;R0.2
	RLC A
	MOV SDA,C
	SETB SCK
	LCALL DELAY_SCK
	CLR SCK
;R0.1
	RLC A
	MOV SDA,C
	SETB SCK
	LCALL DELAY_SCK
	CLR SCK
;R0.0
	RLC A
	MOV SDA,C
	SETB SCK
	LCALL DELAY_SCK
	CLR SCK
;test ack	
	SETB SDA
	SETB SCK
	LCALL DELAY_SCK
	MOV C,SDA
	JNC WRITE_MEM2
	LCALL DELAY_SCK
	MOV C,SDA
	JNC WRITE_MEM2
	LCALL DELAY_SCK
	MOV C,SDA
	JNC WRITE_MEM2
	LJMP WRITE_MEM0
WRITE_MEM2:
	CLR SCK
;ZAPIS DANYCH
	POP ACC
;D.7
	MOV C,ACC.7
	MOV SDA,C
	SETB SCK
	LCALL DELAY_SCK
	CLR SCK
;D.6
	MOV C,ACC.6
	MOV SDA,C
	SETB SCK
	LCALL DELAY_SCK
	CLR SCK
;D.5
	MOV C,ACC.5
	MOV SDA,C
	SETB SCK
	LCALL DELAY_SCK
	CLR SCK
;D.4
	MOV C,ACC.4
	MOV SDA,C
	SETB SCK
	LCALL DELAY_SCK
	CLR SCK
;D.3
	MOV C,ACC.3
	MOV SDA,C
	SETB SCK
	LCALL DELAY_SCK
	CLR SCK
;D.2
	MOV C,ACC.2
	MOV SDA,C
	SETB SCK
	LCALL DELAY_SCK
	CLR SCK
;D.1
	MOV C,ACC.1
	MOV SDA,C
	SETB SCK
	LCALL DELAY_SCK
	CLR SCK
;D.0
	MOV C,ACC.0
	MOV SDA,C
	SETB SCK
	LCALL DELAY_SCK
	CLR SCK
	SETB SDA
	SETB SCK
	LCALL DELAY_SCK
	MOV C,SDA
	JNC WRITE_MEM3
	LCALL DELAY_SCK
	MOV C,SDA
	JNC WRITE_MEM3
	LCALL DELAY_SCK
	MOV C,SDA
	JNC WRITE_MEM3
	LJMP WRITE_MEM
WRITE_MEM3:
;STOP
	CLR SCK
	CLR SDA
	SETB SCK
	LCALL DELAY_SCK
	SETB SDA
	SETB EA;!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
	RET
;opoznienie dla szyny sck
DELAY_SCK:
	PUSH ACC
	MOV A,#DELAY_CLK
	DJNZ ACC,$
	POP ACC
	RET
;*********************************************
;tryb serwisowy
SERVIS:
	PUSH DPH
	PUSH DPL
	CLR TR0
	MOV DPTR,#SERVIS_TAB
	LCALL MONITOR
	SETB PX_1
	CLR PX_2
	MOV B,#01FH; 0.1A
	MOV A,#0FFH; 2,5V
	LCALL SEND1	; wysylanie danych do zasilacza nr1
	MOV B,#01FH; 0.1A
	MOV A,#0FFH; 2,5V
	LCALL SEND2	; wysylanie danych do zasilacza nr2
SERV1:
	LCALL DELAY10
	MOV C,KEY_ENTER
	JNC SERV1
	MOV IE,#00000001B		
	SETB EA
SERV1A:
	MOV KEY,#00H
	LCALL DELAY10
	MOV A,KEY
	CJNE A,#ENTER,SERV1A
	MOV B,#01FH; 0.1A
	MOV A,#07FH; 2,6V
	MOV MEM1,A
	MOV MEM12,B
	LCALL SEND1	; wysylanie danych do zasilacza nr1
	MOV A,#LINE3_LCD
	LCALL LCD
;	MOV LINE,#LINE3_LCD
	MOV A,#'2'
	LCALL WRITE_LCD
	MOV A,#'.'
	LCALL WRITE_LCD
	MOV A,#'6'
	LCALL WRITE_LCD
	MOV A,#SHIFT_CURSORR
	MOV B,#03H
SERV2:
	LCALL LCD
	DJNZ B,SERV2
	MOV A,#'<'
	LCALL WRITE_LCD
	MOV KEY,#00H
	MOV R7,#07H
SERV3:
	MOV A,KEY
	JZ SERV3
	CJNE A,#UP,SERV3B
	CJNE R7,#039,SERV3A
	MOV KEY,#00H
	SJMP SERV3
SERV3A:
	MOV A,MEM1
	SETB C
	RRC A
	MOV MEM1,A
	MOV A,MEM12
	MOV ACC.0,C
	MOV MEM12,A
	MOV A,MEM1
	MOV B,MEM12
	MOV A,MEM1
	MOV B,MEM12
	LCALL SEND1
	MOV A,#LINE3_LCD
	LCALL LCD
;	MOV LINE,#LINE3_LCD
	INC R7
	MOV DPTR,#TAB_SERV1
	MOV A,R7
	MOVC A,@A+DPTR
	LCALL WRITE_LCD
	INC R7
	MOV A,R7
	MOVC A,@A+DPTR
	LCALL WRITE_LCD
	INC R7
	MOV A,R7
	MOVC A,@A+DPTR
	LCALL WRITE_LCD
	INC R7
	MOV A,R7
	MOVC A,@A+DPTR
	LCALL WRITE_LCD
SERV3B:
	CJNE A,#DOWN,SERV3F
	CJNE R7,#07,SERV3C
	MOV KEY,#00H
	SJMP SERV3
SERV3C:
	MOV A,MEM1
	CJNE A,#0FFH,SERV3D
	MOV MEM1,#0FEH
	MOV MEM12,#01FH
	MOV A,MEM1
	MOV B,MEM12
	MOV A,MEM1
	MOV B,MEM12
	LCALL SEND1
	SJMP SERV3E
SERV3D:
	SETB C
	RLC A
	MOV MEM1,A
	MOV B,MEM12
	MOV A,MEM1
	MOV B,MEM12
	LCALL SEND1
SERV3E:
	CLR C
	MOV A,R7
	SUBB A,#08H
	MOV R7,A
	MOV A,#LINE3_LCD
	LCALL LCD
;	MOV LINE,#LINE3_LCD
	INC R7
	MOV DPTR,#TAB_SERV1
	MOV A,R7
	MOVC A,@A+DPTR
	LCALL WRITE_LCD
	INC R7
	MOV A,R7
	MOVC A,@A+DPTR
	LCALL WRITE_LCD
	INC R7
	MOV A,R7
	MOVC A,@A+DPTR
	LCALL WRITE_LCD
	INC R7
	MOV A,R7
	MOVC A,@A+DPTR
	LCALL WRITE_LCD
SERV3F:
	CJNE A,#ENTER,SERV3F1
	SJMP SERV3G
SERV3F1:
	MOV KEY,#00H
	LJMP SERV3
SERV3G:
	MOV A,#LINE3_LCD
	LCALL LCD
;	MOV LINE,#LINE3_LCD
	MOV A,#SHIFT_CURSORR
	MOV B,#06H
SERV4:
	LCALL LCD
	DJNZ B,SERV4
	MOV A,#' '
	LCALL WRITE_LCD
	MOV A,#SHIFT_CURSORR
	MOV B,#05H
SERV4A:
	LCALL LCD
	DJNZ B,SERV4A
	MOV A,#'6'
	LCALL WRITE_LCD
	MOV A,#' '
	LCALL WRITE_LCD
	MOV A,#'V'
	LCALL WRITE_LCD
	MOV A,#' '
	LCALL WRITE_LCD
	MOV A,#'<'
	LCALL WRITE_LCD
	MOV B,#01FH; 0.1A
	MOV A,#07FH; 2,6V
	MOV MEM2,A
	MOV MEM22,B
	LCALL SEND2	; wysylanie danych do zasilacza nr1
	MOV KEY,#00H
	MOV R7,#07H
SERV13:
	MOV A,KEY
	JZ SERV13
	CJNE A,#UP,SERV13B
	CJNE R7,#039,SERV13A
	MOV KEY,#00H
	SJMP SERV13
SERV13A:
	MOV A,MEM2
	SETB C
	RRC A
	MOV MEM2,A
	MOV A,MEM22
	MOV ACC.0,C
	MOV MEM22,A
	MOV A,MEM2
	MOV B,MEM22
	LCALL SEND2
	MOV A,#LINE3_LCD
	LCALL LCD
;	MOV LINE,#LINE3_LCD
	MOV A,#SHIFT_CURSORR
	MOV B,#0AH
SERV13A1:
	LCALL LCD
	DJNZ B,SERV13A1
	INC R7
	MOV DPTR,#TAB_SERV1
	MOV A,R7
	MOVC A,@A+DPTR
	LCALL WRITE_LCD
	INC R7
	MOV A,R7
	MOVC A,@A+DPTR
	LCALL WRITE_LCD
	INC R7
	MOV A,R7
	MOVC A,@A+DPTR
	LCALL WRITE_LCD
	INC R7
	MOV A,R7
	MOVC A,@A+DPTR
	LCALL WRITE_LCD
SERV13B:
	CJNE A,#DOWN,SERV13F
	CJNE R7,#07,SERV13C
	MOV KEY,#00H
	SJMP SERV13
SERV13C:
	MOV A,MEM2
	CJNE A,#0FFH,SERV13D
	MOV MEM2,#0FEH
	MOV MEM22,#01FH
	MOV A,MEM2
	MOV B,MEM22
	LCALL SEND2
	SJMP SERV13E
SERV13D:
	SETB C
	RLC A
	MOV MEM2,A
	MOV B,MEM22
	MOV A,MEM2
	LCALL SEND2
SERV13E:
	CLR C
	MOV A,R7
	SUBB A,#08H
	MOV R7,A
	MOV A,#LINE3_LCD
	LCALL LCD
;	MOV LINE,#LINE3_LCD
	MOV A,#SHIFT_CURSORR
	MOV B,#0AH
SERV13E1:
	LCALL LCD
	DJNZ B,SERV13E1
	INC R7
	MOV DPTR,#TAB_SERV1
	MOV A,R7
	MOVC A,@A+DPTR
	LCALL WRITE_LCD
	INC R7
	MOV A,R7
	MOVC A,@A+DPTR
	LCALL WRITE_LCD
	INC R7
	MOV A,R7
	MOVC A,@A+DPTR
	LCALL WRITE_LCD
	INC R7
	MOV A,R7
	MOVC A,@A+DPTR
	LCALL WRITE_LCD
SERV13F:
	CJNE A,#ENTER,SERV13F1
	SJMP SERV13G
SERV13F1:
	MOV KEY,#00H
	LJMP SERV13
SERV13G:
	MOV A,#LINE3_LCD
	LCALL LCD
;	MOV LINE,#LINE3_LCD
	MOV A,#SHIFT_CURSORR
	MOV B,#16
SERV20:
	LCALL LCD
	DJNZ B,SERV20
	MOV A,#' '
	LCALL WRITE_LCD
	MOV A,#LINE4_LCD
	LCALL LCD
;	MOV LINE,#LINE4_LCD
	MOV A,#SHIFT_CURSORR
	MOV B,#0EH
SERV20A:
	LCALL LCD
	DJNZ B,SERV20A
	MOV A,#'<'
	LCALL WRITE_LCD
	MOV KEY,#00H
	MOV R7,#0FFH
	MOV R6,#0FFH
SERV21:
	MOV A,KEY
	JZ SERV21
	CJNE A,#UP,SERV30
	MOV A,R7
	CJNE A,#26,SERV21B
	MOV KEY,#00H
	SJMP SERV21
SERV21B:
	INC R7
	MOV A,#LINE4_LCD
	LCALL LCD
;	MOV LINE,#LINE4_LCD
	MOV B,#09H
	MOV A,#SHIFT_CURSORR
SERV21A:
	LCALL LCD
	DJNZ B,SERV21A
	MOV DPTR,#TAB_SERV2
	MOV A,R7
	MOVC A,@A+DPTR
	LCALL WRITE_LCD
	INC R7
	MOV A,R7
	MOVC A,@A+DPTR
	LCALL WRITE_LCD
	INC R7
	MOV A,R7
	MOVC A,@A+DPTR
	LCALL WRITE_LCD
	MOV KEY,#00H
	INC R6
	PUSH DPH
	PUSH DPL
	MOV DPTR,#TAB_I
	MOV A,R6
	MOVC A,@A+DPTR
	POP DPL
	POP DPH
	MOV B,A ; warto pradu
	MOV MEM12,A
	MOV A,MEM1
	LCALL SEND1
	MOV A,MEM12
	MOV MEM22,A
	MOV B,A
	MOV A,MEM2
	LCALL SEND2
	SJMP SERV21
SERV30:
	CJNE A,#DOWN,SERV40; ENTER
	MOV A,R7
	DEC A
	DEC A
	JNZ SERV31
	MOV KEY,#00H
	SJMP SERV21
SERV31:
	DEC A
	DEC A;
	DEC A;
	MOV R7,A
	MOV A,#LINE4_LCD
	LCALL LCD
;	MOV LINE,#LINE4_LCD
	MOV B,#09H;
	MOV A,#SHIFT_CURSORR
SERV31A:
	LCALL LCD
	DJNZ B,SERV31A
	MOV DPTR,#TAB_SERV2
	MOV A,R7
	MOVC A,@A+DPTR
	LCALL WRITE_LCD
	INC R7
	MOV A,R7
	MOVC A,@A+DPTR
	LCALL WRITE_LCD
	INC R7
	MOV A,R7
	MOVC A,@A+DPTR
	LCALL WRITE_LCD
	MOV KEY,#00H
	DEC R6
	PUSH DPH
	PUSH DPL
	MOV DPTR,#TAB_I
	MOV A,R6
	MOVC A,@A+DPTR
	;LCALL WRITE_LCD
	POP DPL
	POP DPH
	MOV B,A ; warto pradu
	MOV MEM12,A
	MOV A,MEM1
	LCALL SEND1
	MOV A,MEM12
	MOV MEM22,A
	MOV B,A
	MOV A,MEM2
	LCALL SEND2
	LJMP SERV21
SERV40:
	MOV DPTR,#TAB_SERV3
	LCALL MONITOR
SERV40B:
	MOV A,#LINE3_LCD
	LCALL LCD
;	MOV LINE,#LINE3_LCD
	MOV A,#'>'
	LCALL WRITE_LCD
SERV40A:
	MOV KEY,#00H
SERV41:
	LCALL DELAY10
	MOV A,KEY
	JZ SERV41
	CJNE A,#DOWN,SERV41A
	SJMP SERV50
SERV41A:
	CJNE A,#ENTER,SERV40A
	LJMP SERV_END
SERV50:
	MOV A,#LINE3_LCD
	LCALL LCD
;	MOV LINE,#LINE3_LCD
	MOV A,#' '
	LCALL WRITE_LCD
	MOV A,#LINE4_LCD
	LCALL LCD
;	MOV LINE,#LINE4_LCD
	MOV A,#'>'
	LCALL WRITE_LCD
SERV50A:
	MOV KEY,#00H
SERV51:
	LCALL DELAY10
	MOV A,KEY
	JZ SERV51
	CJNE A,#UP,SERV52
	MOV A,#LINE4_LCD
	LCALL LCD
;	MOV LINE,#LINE4_LCD
	MOV A,#' '
	LCALL WRITE_LCD
	SJMP SERV40B
SERV52:
	CJNE A,#ENTER,SERV50A
;FORMATOWANIE PAMIECI
;ORGANIZACJA PAMIECI EEPROM
;pierwsza kom zawera inf ile jest zapisanych kom pam.
;0: 'N' - NIEZLAEZNE
;   'S' - SZEREGOWE
;   'R' - ROWNOLEGE
;1: U1 Z TABELI TAB_U2 (JESLI FF-WTEDY TAB_U1)
;2: U1 Z TABELI TAB_U1 
;3: I1-MAX
;4: U2 Z TABELI TAB_U2 (JESLI FF-WTEDY TAB_U1)
;5: U2 Z TABELI TAB_U1 
;6: I2-MAX
;M1 szeregowe 2x5V 1A
;M2 szeregowe 2x12V 1A
;M3 niezalezne 5V 1A, 12V 3A
;M4 rownolegle 5V 2X 5A
;M5 rownolegle 12V 2x 5A
;M6 rownolegle 13,6V 2x5A
;M7 rownolegle 14,4V 2x5A
	PUSH DPL
	PUSH DPH
	MOV DPTR,#TAB_EEPROM
	MOV R0,#00H
	MOV A,#00H
SERV53:
	MOVC A,@A+DPTR
	LCALL WRITE_MEM ;eeprom zawiera 7 nastaw
	INC R0
	MOV A,R0
	CJNE A,#047H,SERV53
	POP DPH
	POP DPL
	MOV EEPROM1,#'R'
	MOV EEPROM2,#0FFH
	MOV EEPROM3,#11101001B	;9,0 64
	MOV EEPROM4,#11101111B ;5A
	MOV EEPROM5,#0FFH
	MOV EEPROM6,#11101001B	;9,0 64
	MOV EEPROM7,#11101111B ;5A
	DEC R0
;					dodatkowe zapisy
	MOV A,#21
SERV6:
	PUSH ACC
	INC R0
	ACALL EEPROM_WRITE
	POP ACC
	DJNZ ACC,SERV6
SERV_END:
	POP DPL
	POP DPH
	RET
;zapis danych z komrek eeprom1-7 do eeprom po r0
EEPROM_WRITE:
	PUSH PSW
	PUSH ACC
	MOV A,EEPROM1
;	MOV A,#LINE1_LCD		;!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
;	MOV A,EEPROM1			;!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
;	LCALL WRITE_LCD		;!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
;	LCALL DISPLAY_BIT		;!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
;	SJMP $
	LCALL WRITE_MEM
;	MOV A,#LINE1_LCD		;!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
	INC R0
	MOV A,EEPROM2
;	LCALL DISPLAY_BIT		;!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
;	SJMP $			;!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
	LCALL WRITE_MEM
	INC R0
	MOV A,EEPROM3
	LCALL WRITE_MEM
	INC R0
	MOV A,EEPROM4
	LCALL WRITE_MEM
	INC R0
	MOV A,EEPROM5
	LCALL WRITE_MEM
	INC R0
	MOV A,EEPROM6
	LCALL WRITE_MEM
	INC R0
	MOV A,EEPROM7
	LCALL WRITE_MEM
	POP ACC
	POP PSW
	RET
;zapis pierwotnych danych eeprom po r0
PAM_WRITE:
	PUSH PSW
	PUSH ACC
	MOV A,PAM1
	LCALL WRITE_MEM
	INC R0
	MOV A,PAM2
	LCALL WRITE_MEM
	INC R0
	MOV A,PAM3
	LCALL WRITE_MEM
	INC R0
	MOV A,PAM4
	LCALL WRITE_MEM
	INC R0
	MOV A,PAM5
	LCALL WRITE_MEM
	INC R0
	MOV A,PAM6
	LCALL WRITE_MEM
	INC R0
	MOV A,PAM7
	LCALL WRITE_MEM
	POP ACC
	POP PSW
	RET
;wyswietla bajt bit po bicie
DISPLAY_BIT:
	PUSH PSW
	PUSH ACC
	RLC A
	PUSH ACC
	MOV A,#'0'
	JNC DISPLAY_BIT1
	MOV A,#'1'
DISPLAY_BIT1:
	LCALL WRITE_LCD	;ACC.7
	POP ACC
	RLC A
	PUSH ACC
	MOV A,#'0'
	JNC DISPLAY_BIT2
	MOV A,#'1'
DISPLAY_BIT2:
	LCALL WRITE_LCD	;ACC.6
	POP ACC
	RLC A
	PUSH ACC
	MOV A,#'0'
	JNC DISPLAY_BIT3
	MOV A,#'1'
DISPLAY_BIT3:
	LCALL WRITE_LCD	;ACC.5
	POP ACC
	RLC A
	PUSH ACC
	MOV A,#'0'
	JNC DISPLAY_BIT4
	MOV A,#'1'
DISPLAY_BIT4:
	LCALL WRITE_LCD	;ACC.4
	POP ACC
	RLC A
	PUSH ACC
	MOV A,#'0'
	JNC DISPLAY_BIT5
	MOV A,#'1'
DISPLAY_BIT5:
	LCALL WRITE_LCD	;ACC.3
	POP ACC
	RLC A
	PUSH ACC
	MOV A,#'0'
	JNC DISPLAY_BIT6
	MOV A,#'1'
DISPLAY_BIT6:
	LCALL WRITE_LCD	;ACC.2
	POP ACC
	RLC A
	PUSH ACC
	MOV A,#'0'
	JNC DISPLAY_BIT7
	MOV A,#'1'
DISPLAY_BIT7:
	LCALL WRITE_LCD	;ACC.1
	POP ACC
	RLC A
	MOV A,#'0'
	JNC DISPLAY_BIT8
	MOV A,#'1'
DISPLAY_BIT8:
	LCALL WRITE_LCD	;ACC.0
	POP ACC
	POP PSW
	RET
;*********************************************
;         SPIS TABEL ZNAKOW
;****************************************************
TABIDENT:
	DB '  CYFROWY ZASILACZ  ';
	DB ' U=  2x 2,5-30V     ';
	DB '    Imax= 2x 5A     ';
	DB '                    ';
SERVIS_TAB:
	DB '   TRYB SERWISOWY   '
	DB 'U1:      U2:        '
	DB '2,5 V     2,5 V     '
	DB 'Imax= 2x 0,1A       '
TAB_U1:
;	MOV A,#0FFH;IC3:Q8   Q7   Q6   Q5  Q4 Q3 Q2 Q1
			;  0,1V 0,2V 0,3V 0,5V 1V 2V 4V 8V				
			;1 <=> Uout off
	DB 11111111B	;2,5 0
	DB 01111111B	;2,6 1
	DB 10111111B	;2,7 2
	DB 11011111B	;2,8 3
	DB 01011111B	;2,9 4
	DB 11101111B	;3   5
	DB 01101111B	;3,1 6
	DB 10101111B	;3,2 7
	DB 11001111B	;3,3 8
	DB 01001111B	;3,4 9
	DB 11110111B	;3,5 10
	DB 01110111B	;3,6 11
	DB 10110111B	;3,7 12
	DB 00110111B	;3,8 13
	DB 01010111B	;3,9 14
	DB 11100111B	;4,0 15
	DB 01100111B	;4,1 16
	DB 10100111B	;4,2 17
	DB 11000111B	;4,3 18
	DB 01000111B	;4,4 19
	DB 11111011B	;4,5 20
	DB 01111011B	;4,6 20
	DB 10111011B	;4,7 21
	DB 11011011B	;4,8 22
	DB 01011011B	;4,9 23
	DB 11101011B	;5,0 24
	DB 01101011B	;5,1 25
	DB 10101011B	;5,2 26
	DB 11001011B	;5,3 27
	DB 01001011B	;5,4 28
	DB 10001011B	;5,5 29
	DB 00001011B	;5,6 30
	DB 10110011B	;5,7 31
	DB 00110011B	;5,8 32
	DB 01010011B	;5,9 33
	DB 11100011B	;6,0 34
	DB 01100011B	;6,1 35
	DB 10100011B	;6,2 36
	DB 00100011B	;6,3 37
	DB 01000011B	;6,4 38
	DB 10000011B	;6,5 39
	DB 00000011B	;6,6 40
	DB 10111101B	;6,7 41
	DB 00111101B	;6,8 42
	DB 01011101B	;6,9 43
	DB 11101101B	;7,0 44   0,1V 0,2V 0,3V 0,5V 1V 2V 4V 8V				
	DB 01101101B	;7,1 45
	DB 10101101B	;7,2 46
	DB 00101101B	;7,3 47
	DB 01001101B	;7,4 48
	DB 10001101B	;7,5 49
	DB 00001101B	;7,6 50
	DB 10110101B	;7,7 51
	DB 00110101B	;7,8 52
	DB 01010101B	;7,9 53
	DB 11100101B	;8,0 54
	DB 01100101B	;8,1 55
	DB 10100101B	;8,2 56
	DB 11000101B	;8,3 57
	DB 01000101B	;8,4 58
	DB 10000101B	;8,5 59
	DB 00000101B	;8,6 60
	DB 10111001B	;8,7 61
	DB 00111001B	;8,8 62
	DB 01011001B	;8,9 63
	DB 11101001B	;9,0 64
	DB 01101001B	;9,1 65
	DB 10101001B	;9,2 66
	DB 00101001B	;9,3 67
	DB 01001001B	;9,4 68
	DB 10001001B	;9,5 69
	DB 00001001B	;9,6 70
	DB 01110001B	;9,6 71
	DB 10110001B	;9,7 72
	DB 11010001B	;9,8 73
	DB 01010001B	;9,9 74
	DB 10010001B	;10,0 75
	DB 00010001B	;10,1 76
	DB 10100001B	;10,2 77    0,1V 0,2V 0,3V 0,5V 1V 2V 4V 8V				
	DB 11000001B	;10,3 78
	DB 01000001B	;10,4 79
	DB 10000001B	;10,5 80
	DB 00000001B	;10,6 81
	DB 10111110B	;10,7 82
	DB 11011110B	;10,8 83
	DB 01011110B	;10,9 84
	DB 10011110B	;11,0 85
	DB 00011110B	;11,1 86
	DB 10101110B	;11,2 87
	DB 00101110B	;11,3 88
	DB 01001110B	;11,4 89
	DB 10001110B	;11,5 90
	DB 00001110B	;11,6 91
	DB 10110110B	;11,7 92
	DB 00110110B	;11,8 93
	DB 01010110B	;11,9 94
	DB 10010110B	;11,9 95
	DB 00010110B	;12,0 96
	DB 01100110B	;12,1 97
	DB 10100110B	;12,2 98
	DB 00100110B	;12,3 99
	DB 01000110B	;12,4 100
	DB 10000110B	;12,5 101
	DB 00000110B	;12,6 102
	DB 10111010B	;12,7 103
	DB 00111010B	;12,8 104
	DB 01011010B	;12,9 105
	DB 10011010B	;13,0 106
	DB 00011010B	;13,1 107
	DB 10101010B	;13,2 108     0,1V 0,2V 0,3V 0,5V 1V 2V 4V 8V				
	DB 00101010B	;13,3 109     
	DB 01001010B	;13,4 110     
	DB 10001010B	;13,5 111     
	DB 00001010B	;13,6 112     
	DB 10110010B	;13,7 113     
	DB 00110010B	;13,8 114     
	DB 01010010B	;13,9 115     
	DB 10010010B	;14,0 116
	DB 00010010B	;14,1 117
	DB 10100010B	;14,2 118
	DB 00100010B	;14,3 119
	DB 01000010B	;14,4 120
	DB 10000010B	;14,5 121
	DB 00000010B	;14,6 122
	DB 10111100B	;14,7 123
	DB 00111100B	;14,8 124
	DB 01011100B	;14,9 125
	DB 10011100B	;15,0 126
	DB 00011100B	;15,1 127
	DB 10101100B	;15,2 128
	DB 00101100B	;15,3 129
	DB 01001100B	;15,4 130
	DB 10001100B	;15,5 131
	DB 00001100B	;15,6 132
	DB 10110100B	;15,7 133
	DB 00110100B	;15,8 134
	DB 01010100B	;15,9 135
	DB 10010100B	;16,0 136
	DB 00010100B	;16,1 137
	DB 10100100B	;16,2 138     0,1V 0,2V 0,3V 0,5V 1V 2V 4V 8V				
	DB 00100100B	;16,3 139
	DB 01000100B	;16,4 140
	DB 10000100B	;16,5 141
	DB 00000100B	;16,6 142
	DB 10111000B	;16,7 143
	DB 00111000B	;16,8 144
	DB 01011000B	;16,9 145
	DB 10011000B	;17,0 146
	DB 00011000B	;17,1 147
	DB 10101000B	;17,2 148
	DB 00101000B	;17,3 149
	DB 01001000B	;17,4 150
	DB 10001000B	;17,5 151
	DB 00001000B	;17,6 152
	DB 10110000B	;17,7 153
	DB 00110000B	;17,8 153
	DB 01010000B	;17,9 154
	DB 10010000B	;18,0 155
	DB 00010000B	;18,1 156
	DB 10100000B	;18,2 157
	DB 00100000B	;18,3 158
	DB 01000000B	;18,4 159
	DB 10000000B	;18,5 160
	DB 00000000B	;18,6 161
;****************************************************
TAB_U2:
	DB 10110111B	;18,7 1 +17,5V
	DB 00110111B	;18,8 2 +17,5V
	DB 01010111B	;18,9 3
	DB 10010111B	;19,0 4
	DB 00010111B	;19,1 5
	DB 10100111B	;19,2 6
	DB 00100111B	;19,3 7
	DB 01000111B	;19,4 8
	DB 10000111B	;19,5 9
	DB 00000111B	;19,6 10
	DB 10111011B	;19,7 11
	DB 00111011B	;19,8 12
	DB 01011011B	;19,9 13
	DB 10011011B	;20,0 14
	DB 00011011B	;20,1 15
	DB 10101011B	;20,2 16
	DB 00101011B	;20,3 17
	DB 01001011B	;20,4 18
	DB 10001011B	;20,5 19
	DB 00001011B	;20,6 20
	DB 10110011B	;20,7 21
	DB 00110011B	;20,8 22
	DB 01010011B	;20,9 23
	DB 10010011B	;21,0 24
	DB 00010011B	;21,1 25
	DB 10100011B	;21,2 26
	DB 00100011B	;21,3 27
	DB 01000011B	;21,4 28
	DB 10000011B	;21,5 29
	DB 00000011B	;21,6 30     0,1V 0,2V 0,3V 0,5V 1V 2V 4V 8V				
	DB 10111101B	;21,7 31
	DB 00111101B	;21,8 32
	DB 01011101B	;21,9 33
	DB 10011101B	;22,0 34
	DB 00011101B	;22,1 35
	DB 10101101B	;22,2 36
	DB 00101101B	;22,3 37
	DB 01001101B	;22,4 38
	DB 10001101B	;22,5 39
	DB 00001101B	;22,6 40
	DB 10110101B	;22,7 41
	DB 00110101B	;22,8 42
	DB 01010101B	;22,9 43
	DB 10010101B	;23,0 44
	DB 00010101B	;23,1 45
	DB 10100101B	;23,2 46
	DB 00100101B	;23,3 47
	DB 01000101B	;23,4 48
	DB 10000101B	;23,5 49
	DB 00000101B	;23,6 50
	DB 10111001B	;23,7 51
	DB 00111001B	;23,8 52
	DB 01011001B	;23,9 53
	DB 10011001B	;24,0 54
	DB 00011001B	;24,1 55
	DB 10101001B	;24,2 56
	DB 00101001B	;24,3 57
	DB 01001001B	;24,4 58
	DB 10001001B	;24,5 59
	DB 00001001B	;24,6 60
	DB 10110001B	;24,7 61     0,1V 0,2V 0,3V 0,5V 1V 2V 4V 8V
	DB 00110001B	;24,8 62
	DB 01010001B	;24,9 63
	DB 10010001B	;25,0 64
	DB 00010001B	;25,1 65
	DB 10100001B	;25,2 66
	DB 00100001B	;25,3 67
	DB 01000001B	;25,4 68
	DB 10000001B	;25,5 69
	DB 00000001B	;25,6 70
	DB 10111110B	;25,7 71
	DB 00111110B	;25,8 72
	DB 01011110B	;25,9 73
	DB 10011110B	;26,0 74
	DB 00011110B	;26,1 75
	DB 10101110B	;26,2 76
	DB 00101110B	;26,3 77
	DB 01001110B	;26,4 78
	DB 10001110B	;26,5 79
	DB 00001110B	;26,6 80
	DB 10110110B	;26,7 81
	DB 00110110B	;26,8 82
	DB 01010110B	;26,9 83
	DB 10010110B	;27,0 84
	DB 00010110B	;27,1 85
	DB 10100110B	;27,2 86
	DB 00100110B	;27,3 87
	DB 01000110B	;27,4 88
	DB 10000110B	;27,5 89
	DB 00000110B	;27,6 90
	DB 10111010B	;27,7 91
	DB 00111010B	;27,8 92
	DB 01011010B	;27,9 93
	DB 10011010B	;28,0 94 +17,5V
	DB 00011010B	;28,1 95
	DB 10101010B	;28,2 96     0,1V 0,2V 0,3V 0,5V 1V 2V 4V 8V
	DB 00101010B	;28,3 97
	DB 01001010B	;28,4 98
	DB 10001010B	;28,5 99
	DB 00001010B	;28,6 100
	DB 10110010B	;28,7 101
	DB 00110010B	;28,8 102
	DB 01010010B	;28,9 103
	DB 10010010B	;29,0 104
	DB 00010010B	;29,1 105
	DB 10100010B	;29,2 106
	DB 00100010B	;29,3 107
	DB 01000010B	;29,4 108
	DB 10000010B	;29,5 109
	DB 00000010B	;29,6 110
	DB 10111100B	;29,7 111
	DB 00111100B	;29,8 112
	DB 01011100B	;29,9 113
	DB 10011100B	;30,0 114
;*******************************************************
TAB_SERV1:
	DB '2.5 '
	DB '2.6 '
	DB '2.7 '
	DB '2.8 '
	DB '3.0 '
	DB '3.5 '
	DB '4.5 '
	DB '6.5 '
	DB '10.5'
	DB '17.5'
TAB_I:
;	DB 'a'
;	DB 'b'
;	DB 'c'
;	DB 'd'
;	DB 'e'
;	DB 'f'
;	DB 'g'
;	DB 'h'
;	DB 'i'
;	DB 'j'
	DB 00011111B ;0,1A	0
	DB 10011111B ;0,2A	1
	DB 01011111B ;0,3A	2
	DB 11011111B ;0,5A	3
	DB 00111111B ;0,8A	4
	DB 10111111B ;1A		5
	DB 01111111B ;2A		6
	DB 11111111B ;3A		7
	DB 11101111B ;5A		8
				;Q1 =0 <=>15V ON
				;Q5 =0 <=> 5A 0N
				;******************************
				;Q8 Q7 Q6 Q5 Q4 Q3 Q2 Q1
				;0  0  0  1  X   X  X  X <=> 0,1A
				;0  0  1  1  X   X  X  X <=> 0,8A
				;0  1  0  1  X   X  X  X <=> 0,3A
				;0  1  1  1  X   X  X  X <=> 2A
				;1  0  0  1  X   X  X  X <=> 0,2A
				;1  0  1  1  X   X  X  X <=> 1A
				;1  1  0  1  X   X  X  X <=> 0,5A
				;1  1  1  1  X   X  X  X <=> 3A
TAB_SERV2:
	DB '0.1'
	DB '0.2'
	DB '0.3'
	DB '0.5'
	DB '0.8'
	DB '1.0'
	DB '2.0'
	DB '3.0'
	DB '5.0'
TAB_SERV3:
	DB '   CZY FORMATOWAC   '
	DB '     EEPROM?        '
	DB '  NIE               '
	DB '  TAK               '
TAB_N:
	DB 'NIEZALEZNIE'
TAB_S:
	DB ' SZEREGOWO '
TAB_R:
	DB 'ROWNOLEGLE '
TAB_ERROR1:
	DB '  ERROR 1  '
TAB_MENU1:
	DB 'M                   '
	DB 'U1=  , V   U2=  , V '
	DB 'I1= ,  A   I2= ,  A '
	DB 'Imax= , A  Imax= , A'
TAB_MENU2:
	DB 'ZAPISAC DO PAMIECI? '
TAB_MENU3:
	DB 'WROCIC DO REGULACJI?'
TAB_MENU4:
	DB ' POWROT BEZ ZAPISU? '
TAB_EEPROM:
	DB 030H
	DB 'N'
	DB 0FFH
	DB 11101011B	;5,0V 24
	DB 10111111B ;1A
	DB 0FFH
	DB 11101011B	;5,0V 24
	DB 10111111B ;1A
;				M1: 2x12V 1A
	DB 'S'
	DB 0FFH
	DB 00010110B	;12,0 96
	DB 10111111B ;1A
	DB 0FFH
	DB 00010110B	;12,0 96
	DB 10111111B ;1A
;				M3 niezalezne 5V 1A, 12V 3A
	DB 'N'
	DB 0FFH
	DB 11101011B	;5,0V 24
	DB 10111111B ;1A
	DB 0FFH
	DB 00010110B	;12,0 96
	DB 11111111B ;3A
;				M4 rownolegle 5V 2X 5A
	DB 'R'
	DB 0FFH
	DB 11101011B	;5,0V 24
	DB 11101111B ;5A
	DB 0FFH
	DB 11101011B	;5,0V 24
	DB 11101111B ;5A
;				M5 rownolegle 12V 2x 5A
	DB 'R'
	DB 0FFH
	DB 00010110B	;12,0 96
	DB 11101111B ;5A
	DB 0FFH
	DB 00010110B	;12,0 96
	DB 11101111B ;5A
;				M6 rownolegle 13,6V 2x5A
	DB 'R'
	DB 0FFH
	DB 00001010B	;13,6 112     
	DB 11101111B ;5A
	DB 0FFH
	DB 00001010B	;13,6 112     
	DB 11101111B ;5A
;				M7 rownolegle 14,4V 2x5A
	DB 'R'
	DB 0FFH
	DB 01000010B	;14,4 120
	DB 11101111B ;5A
	DB 0FFH
	DB 01000010B	;14,4 120
	DB 11101111B ;5A
;				M8 rownolegle 24,0V 2x5A
	DB 'R'
	DB 10011001B	;24,0 54
	DB 0FFH	;
	DB 11101110B ;5A TAB_U2 +17,5V
	DB 10011001B	;24,0 54
	DB 0FFH
	DB 11101110B ;5A
;				M9 niezalezne 5V 1A, 9V 3A
	DB 'N'
	DB 0FFH
	DB 11101011B	;5,0V 24
	DB 10111111B ;1A
	DB 0FFH
	DB 11101001B	;9,0 64
	DB 11111111B ;1A
;				M10 rownolegle 9V 2x5A
	DB 'R'
	DB 0FFH
	DB 11101001B	;9,0 64
	DB 11101111B ;5A
	DB 0FFH
	DB 11101001B	;9,0 64
	DB 11101111B ;5A
