;przetwornik adc do zasilacza cyfrowego


;ostatnie dwa bajty pam. (kalibracja) 54h, 34h
;obsluga timera timer0 
;bez preskalera
; ze wstepnym ustawieniem licznika na wartosc 206
;odlicza 50 cyki maszynowych (fosc/4)i zienia stan led


;definiowanie zmiennych
#define ADC_U GPIO, 0			;wejscie pomiaru U przetwornika
#define ADC_I GPIO, 1			;wejscie pomiaru I przetwornika ADC
#define CLK GPIO, 4			;wejscie zegarowe przetwornika
#define DATA GPIO, 5			;wyjscie danych przetwornika


#define dph 20h				; starszy bajt pomocniczy
#define dpl 21h				; mlodszy bajt pomocniczy
#define licznik h'22'			; pomocniczy licznik petli opoznienia
#define stos h'23'			; pomocniczy rejestr zapamietujacy zmienne jak stos
#define time_counter h'24'			; pam. predkosci
#define DATA_OUT0 h'25'			; dane do wysyki
#define U_H h'26'				; pomiar U MSB (dwie starsze cyfry BCD)
#define U_L h'27'				; pomiar U LSB (najmlodsza cyfra BCD) 
#define I_H h'28'				; pomiar I MSB (dwie starsze cyfry BCD)
#define I_L h'29'				; pomiar I LSB (najmlodsza cyfra BCD) 
#define DATA_X100 h'2a'			; pomocnicza dana MSB 
#define DATA_X10 h'2b'			; pomocnicza dana LSB 
#define DATA_X1 h'2c'			; pomocnicza dana LSB 
#define DATA_H h'2d'			; pomocnicza dana MSB
#define DATA_L h'2e'			; pomocnicza dana LSB
#define DATA_OUT1 h'2f'			; dane do wysyki
#define DATA_OUT2 h'30'			; dane do wysyki
#define DATA_OUT3 h'31'			; dane do wysyki







;deklaracj typu procesora i formatu liczb
	list p=12F675			;okreslenie typu procesora
	#include p12f675.inc	;dolaczenie pliku z nazwami

;konfiguracja procesora
	__config _INTRC_OSC_NOCLKOUT &_MCLRE_OFF &_WDT_OFF; gen wew. RC bez wyjscia 
									;wlaczone wejscie reset
									;watch dog wylaczony
	org 0
	goto start
	
;	org 4
;	goto timer_int	; (2CM)
start

;wylacz komparator
	movlw .7
	movwf cmcon

;konfiguracja linii i/o
	bsf status, rp0;bank1

	movlw h'013'				;0001 0011   0=wyjscie, 1=wejscie
	movwf trisio
	movlw h'33'					;0010 0000 rezystor pull up GP5 - prog
	movwf wpu
	bcf option_reg, 7				;zalacza wybrane w wpu rezystory do Vdd
							;GPPU=0 w rej option_reg 7 bit zalacza rezustory z rej. wpu
	bcf status, rp0 ;bank0

;wylacz adc
	;konfiguracja wejscia
	bsf status, rp0 ;bank1
	movlw b'11110011'	;	czestotliwo tj. RC, wejcie ANS2
	movwf ansel

	bcf status, rp0 ;bank0

	movlw b'00110001'	;	just - lewo; Vref=Vdd; ch0; ADC on
	movwf adcon0

	bcf intcon, gie	; zablokuj przerwania
	bcf pir1, adif	;zeruj flage przerwania

;ustawienia przerwania od timera0
;	bsf status, rp0	;bank1
;	movlw b'10001000'	;zliczanie cykli zegarowych bez preskalera
;	movwf option_reg
	bcf status, rp0	;bank0
	clrf intcon
	clrf tmr0	;zeruje timer0 i preskaler
	bcf intcon, t0ie	;zezwolenie na int od timer0 off
	bcf intcon, gie	;ogolny bit zezwolenia na przerwania off
	bsf DATA	
	movlw h'98'	;	czestotliwo tj. RC, wejcie ANS2
	movwf U_H
	movlw h'07'	;	czestotliwo tj. RC, wejcie ANS2
	movwf U_L
	movlw h'32'	;	czestotliwo tj. RC, wejcie ANS2
	movwf I_H
	movlw h'01'	;	czestotliwo tj. RC, wejcie ANS2
	movwf I_L
;********************************************************
;program glowy
	bcf status, rp0	;bank0
	bsf intcon, gie	;ogolny bit zezwolenia na przerwania on
loop
;	call counter
;	goto $
	call detect_start		;funkcja wykrywajaca sygnal startu konwersji
	movf U_H, 0			;przeslij U_H do W
	movwf DATA_OUT0		;przeslij W do data_out (U_H)
	movf U_L, 0			;przeslij U_L do W
	movwf DATA_OUT1		;przeslij W do data_out (U_L)
	movf I_H, 0			;przeslij I_H do W
	movwf DATA_OUT2		;przeslij W do data_out (I_H)
	movf I_L, 0			;przeslij I_L do W
	movwf DATA_OUT3		;przeslij W do data_out (I_L)
	call DATA_TX
	call delay_ux100
	call ADC_converter	;procedura obsugi przetwornika ADC
	goto loop
;#################################################################
;opoznienie o 100 us
delay_ux100
	movlw h'1c'		;1
delay_ux100b
	movwf dpl		;przepisuja W do dpl
	decfsz dpl,0	;1 dekrement, wynik do W, jesli 0 pomin next instr.
	goto delay_ux100b	;1
	return	


;opoznienie o 10 ms
delay10
	movlw h'0b'		;1 bylo 0bh
delay10a
	movwf dph		;1
	movlw h'f2'		;1
delay10b
	movwf dpl	;przepisuja W do dpl
	decfsz dpl,0		;1 dekrement, wynik do W, jesli 0 pomin next instr.
	goto delay10b	;1
	movlw dph	;	wpisz do W dph
	decfsz dph,0	;1 zmniejsz dph, wynik do W, jesli 0 pomin next instr.
	goto delay10a	;1
	return	

;opoznienie o 100ms
delay100ms
	movwf stos 	;zapamietuje W na stosie
	movlw .10
	movwf licznik
	call delay10
	decfsz licznik, f
	goto $-2
	movf stos,0	;oddaje wartosc W
	return


;opoznienie o 1 sek
delay1s
	movwf stos 	;zapamietuje W na stosie
	movlw .100
	movwf licznik
	call delay10
	decfsz licznik, f
	goto $-2
	movf stos,0	;oddaje wartosc W
	return

;przetwarzanie ADC
ADC_converter
	bcf status, rp0
	bcf adcon0, chs0	;kanal 0
	bcf adcon0, chs1	;pomiar U
	call delay10us	;opoznienie na ustabilizowanie 
	bsf adcon0, go	; start konwersji ADC
	btfsc adcon0, go	; czy koniec konwersji
	goto $-1
	call counter	;zamiana 10bit z ADC na 3 x BCD
	movf DATA_H, 0	;starszy bajt konwersji do W
	movwf U_H		;przepisanie W do U_H
	movf DATA_L, 0	;mlodszy bajt konwersji do W
	movwf U_L		;przepisanie W do U_L
	bcf status, rp0
	bsf adcon0, chs0	;kanal 1
	bcf adcon0, chs1	;pomiar I
	call delay10us	;opoznienie na ustabilizowanie 
	bsf adcon0, go	; start konwersji ADC
	btfsc adcon0, go	; czy koniec konwersji
	goto $-1
	call counter	;zamiana 10bit z ADC na 3 x BCD
	movf DATA_H, 0	;starszy bajt konwersji do W
	movwf I_H		;przepisanie W do I_H
	movf DATA_L, 0	;starszy bajt konwersji do W
	movwf I_L		;przepisanie W do I_L
	return
;opoznienie 10us
delay10us
	goto $+1
	goto $+1
	goto $+1
	return

;funkcja wysylajaca dane 
DATA_TX
	bcf data
	btfsc DATA_OUT0, 7
	bsf DATA
	btfss CLK	;oczekuje L->H
	goto $-1
	call delay10us	
	btfsc CLK	;oczekuje H->L
	goto $-1
	call delay10us	
	bcf data
	btfsc DATA_OUT0, 6
	bsf DATA
	btfss CLK	;oczekuje L->H
	goto $-1
	call delay10us	
	btfsc CLK	;oczekuje H->L
	goto $-1
	call delay10us	
	bcf data
	btfsc DATA_OUT0, 5
	bsf DATA
	btfss CLK	;oczekuje L->H
	goto $-1
	call delay10us	
	btfsc CLK	;oczekuje H->L
	goto $-1
	call delay10us	
	bcf data
	btfsc DATA_OUT0, 4
	bsf DATA
	btfss CLK	;oczekuje L->H
	goto $-1
	call delay10us	
	btfsc CLK	;oczekuje H->L
	goto $-1
	call delay10us	
	bcf data
	btfsc DATA_OUT0, 3
	bsf DATA
	btfss CLK	;oczekuje L->H
	goto $-1
	call delay10us	
	btfsc CLK	;oczekuje H->L
	goto $-1
	call delay10us	
	bcf data
	btfsc DATA_OUT0, 2
	bsf DATA
	btfss CLK	;oczekuje L->H
	goto $-1
	call delay10us	
	btfsc CLK	;oczekuje H->L
	goto $-1
	call delay10us	
	bcf data
	btfsc DATA_OUT0, 1
	bsf DATA
	btfss CLK	;oczekuje L->H
	goto $-1
	call delay10us	
	btfsc CLK	;oczekuje H->L
	goto $-1
	call delay10us	
	bcf data
	btfsc DATA_OUT0, 0
	bsf DATA
	btfss CLK	;oczekuje L->H
	goto $-1
	call delay10us	
	btfsc CLK	;oczekuje H->L
	goto $-1
	call delay10us	
	bcf data
	btfsc DATA_OUT1, 3
	bsf DATA
	btfss CLK	;oczekuje L->H
	goto $-1
	call delay10us	
	btfsc CLK	;oczekuje H->L
	goto $-1
	call delay10us	
	bcf data
	btfsc DATA_OUT1, 2
	bsf DATA
	btfss CLK	;oczekuje L->H
	goto $-1
	call delay10us	
	btfsc CLK	;oczekuje H->L
	goto $-1
	call delay10us	
	bcf data
	btfsc DATA_OUT1, 1
	bsf DATA
	btfss CLK	;oczekuje L->H
	goto $-1
	call delay10us	
	btfsc CLK	;oczekuje H->L
	goto $-1
	call delay10us	
	bcf data
	btfsc DATA_OUT1, 0
	bsf DATA
	btfss CLK	;oczekuje L->H
	goto $-1
	call delay10us	
	btfsc CLK	;oczekuje H->L
	goto $-1
	call delay10us	
	bcf data
	btfsc DATA_OUT2, 7
	bsf DATA
	btfss CLK	;oczekuje L->H
	goto $-1
	call delay10us	
	btfsc CLK	;oczekuje H->L
	goto $-1
	call delay10us	
	bcf data
	btfsc DATA_OUT2, 6
	bsf DATA
	btfss CLK	;oczekuje L->H
	goto $-1
	call delay10us	
	btfsc CLK	;oczekuje H->L
	goto $-1
	call delay10us	
	bcf data
	btfsc DATA_OUT2, 5
	bsf DATA
	btfss CLK	;oczekuje L->H
	goto $-1
	call delay10us	
	btfsc CLK	;oczekuje H->L
	goto $-1
	call delay10us	
	bcf data
	btfsc DATA_OUT2, 4
	bsf DATA
	btfss CLK	;oczekuje L->H
	goto $-1
	call delay10us	
	btfsc CLK	;oczekuje H->L
	goto $-1
	call delay10us	
	bcf data
	btfsc DATA_OUT2, 3
	bsf DATA
	btfss CLK	;oczekuje L->H
	goto $-1
	call delay10us	
	btfsc CLK	;oczekuje H->L
	goto $-1
	call delay10us	
	bcf data
	btfsc DATA_OUT2, 2
	bsf DATA
	btfss CLK	;oczekuje L->H
	goto $-1
	call delay10us	
	btfsc CLK	;oczekuje H->L
	goto $-1
	call delay10us	
	bcf data
	btfsc DATA_OUT2, 1
	bsf DATA
	btfss CLK	;oczekuje L->H
	goto $-1
	call delay10us	
	btfsc CLK	;oczekuje H->L
	goto $-1
	call delay10us	
	bcf data
	btfsc DATA_OUT2, 0
	bsf DATA
	btfss CLK	;oczekuje L->H
	goto $-1
	call delay10us	
	btfsc CLK	;oczekuje H->L
	goto $-1
	call delay10us	
	bcf data
	btfsc DATA_OUT3, 3
	bsf DATA
	btfss CLK	;oczekuje L->H
	goto $-1
	call delay10us	
	btfsc CLK	;oczekuje H->L
	goto $-1
	call delay10us	
	bcf data
	btfsc DATA_OUT3, 2
	bsf DATA
	btfss CLK	;oczekuje L->H
	goto $-1
	call delay10us	
	btfsc CLK	;oczekuje H->L
	goto $-1
	call delay10us	
	bcf data
	btfsc DATA_OUT3, 1
	bsf DATA
	btfss CLK	;oczekuje L->H
	goto $-1
	call delay10us	
	btfsc CLK	;oczekuje H->L
	goto $-1
	call delay10us	
	bcf data
	btfsc DATA_OUT3, 0
	bsf DATA
	return
;****************************************************************************
;procedura obliczania BIN 2 3x BCD (datax100....)
counter			
	movlw .246	;
	movwf DATA_X100
	movlw .246	;
	movwf DATA_X10
	movlw .246	;
	movwf DATA_X1
	bsf status, rp0 ;bank1
	btfss adresl ,7	; jesli najstarszy bit konwersji ADC.0=1 omin instr
	goto counter1
	incf DATA_X1, 0	; 2^0 - lsb
	movwf DATA_X1
counter1	
	bcf status, rp0 ;bank0
	btfss adresh ,0	; jesli najstarszy bit konwersji ADC.1=1 omin instr
	goto counter2
	movf DATA_X1, 0	;W:=led1_data - 2^1
	addlw .2
	movwf DATA_X1
counter2
	btfss adresh ,1	; jesli najstarszy bit konwersji ADC.2=1 omin instr
	goto counter3
	movf DATA_X1, 0	;W:=led1_data - 2^2
	addlw .4
	movwf DATA_X1
counter3
	btfss adresh ,2	; jesli najstarszy bit konwersji ADC.3=1 omin instr
	goto counter4
	movf DATA_X1, 0	;W:=led1_data - 2^3
	addlw .8
	movwf DATA_X1
	btfss status, c	; czy nastapilo przeniesienie
	goto counter4
	incf DATA_x10, 0	;
	movwf DATA_x10
	movf DATA_x1, 0	;
	addlw .246	;
	movwf DATA_X1
counter4
	btfss adresh ,3	; jesli najstarszy bit konwersji ADC.4=1 omin instr
	goto counter5
	incf DATA_x10, 0	;
	movwf DATA_x10	;+10
	movf DATA_X1, 0	;
	addlw .6		;+6
	movwf DATA_X1
	btfss status, c	; czy nastapilo przeniesienie
	goto counter5
	incf DATA_x10, 0	;
	movwf DATA_x10
	movf DATA_x1, 0	;
	addlw .246	;
	movwf DATA_X1
counter5
	btfss adresh ,4	; jesli najstarszy bit konwersji ADC.5=1 omin instr +32
	goto counter6
	movf DATA_x10, 0	;
	addlw .3		;+3 x10
	movwf DATA_x10	;+10
	movf DATA_X1, 0	;
	addlw .2		;+2
	movwf DATA_X1
	btfss status, c	; czy nastapilo przeniesienie
	goto counter6
	incf DATA_x10, 0	;
	movwf DATA_x10
	movf DATA_x1, 0	;
	addlw .246	;
	movwf DATA_X1
counter6
	btfss adresh ,5	; jesli najstarszy bit konwersji ADC.5=1 omin instr +64
	goto counter7
	movf DATA_x10, 0	;
	addlw .6		;+6 x10
	movwf DATA_x10	;+10
	btfss status, c	; czy nastapilo przeniesienie
	goto counter6a
	incf DATA_x100, 0	;
	movwf DATA_x100
	movf DATA_x10, 0	;
	addlw .246	;
	movwf DATA_X10
counter6a
	movf DATA_X1, 0	;
	addlw .4		;+4
	movwf DATA_X1
	btfss status, c	; czy nastapilo przeniesienie
	goto counter7
	movf DATA_x1, 0	;
	addlw .246	;
	movwf DATA_X1
	movf DATA_X10, 0	;
	addlw .1		;
	movwf DATA_x10
	btfss status, c	; czy nastapilo przeniesienie
	goto counter7	;!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
	movf DATA_X10, 0	;
	addlw .246		;+8
	movwf DATA_x10
	incf DATA_x100, 0	;
	movwf DATA_x100
counter7
	btfss adresh ,6	; jesli najstarszy bit konwersji ADC.5=1 omin instr +128
	goto counter8
	movf DATA_x100, 0	;
	addlw .1		;+1 x100
	movwf DATA_x100	;+10
	movf DATA_x10, 0	;
	addlw .2		;+2 x10
	movwf DATA_x10	;+10
	btfss status, c	; czy nastapilo przeniesienie
	goto counter7a
	incf DATA_x100, 0	;
	movwf DATA_x100
	movf DATA_x10, 0	;
	addlw .246	;
	movwf DATA_X10
counter7a
	movf DATA_X1, 0	;
	addlw .8		;+8
	movwf DATA_X1
	btfss status, c	; czy nastapilo przeniesienie
	goto counter8
	movf DATA_x1, 0	;
	addlw .246	;
	movwf DATA_X1
	movf DATA_X10, 0	;
	addlw .1		;+8
	movwf DATA_x10
	btfss status, c	; czy nastapilo przeniesienie
	goto counter8	;!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
	movf DATA_X10, 0	;
	addlw .246		;+8
	movwf DATA_x10
	incf DATA_x100, 0	;
	movwf DATA_x100
counter8
	btfss adresh ,7	; jesli najstarszy bit konwersji ADC.5=1 omin instr +256
	goto counter9
	movf DATA_x100, 0	;
	addlw .2		;+2 x100
	movwf DATA_x100	;
	movf DATA_x10, 0	;
	addlw .5		;+5 x10
	movwf DATA_x10	;+10
	btfss status, c	; czy nastapilo przeniesienie
	goto counter8a
	incf DATA_x100, 0	;
	movwf DATA_x100
	movf DATA_x10, 0	;
	addlw .246	;
	movwf DATA_X10
counter8a
	movf DATA_X1, 0	;
	addlw .6		;+8
	movwf DATA_X1
	btfss status, c	; czy nastapilo przeniesienie
	goto counter9	;!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
	movf DATA_x1, 0	;
	addlw .246	;
	movwf DATA_X1
	movf DATA_X10, 0	;
	addlw .1		;+8
	movwf DATA_x10
	btfss status, c	; czy nastapilo przeniesienie
	goto counter9	;!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
	movf DATA_X10, 0	;
	addlw .246		;+8
	movwf DATA_x10
	incf DATA_x100, 0	;
	movwf DATA_x100
counter9
	movf DATA_X1, 0	;
	addlw .10		;
	movwf DATA_X1
	movf DATA_X10, 0	;
	addlw .10		;
	movwf DATA_X10
	movf DATA_X100, 0	;
	addlw .10		;
	movwf DATA_X100
	swapf DATA_X100, 0
	movwf DATA_H
	btfss DATA_X10, 3	
	goto counter9a
	bsf DATA_H, 3
counter9a
	btfss DATA_X10, 2	
	goto counter9b
	bsf DATA_H, 2
counter9b
	btfss DATA_X10, 1	
	goto counter9c
	bsf DATA_H, 1
counter9c
	btfss DATA_X10, 0	
	goto counter9e
	bsf DATA_H, 0
counter9e
	movf DATA_X1, 0	;
	movwf DATA_L
	return
;*****************************************************************************
detect_start		;funkcja wykrywajaca sygnal startu konwersji clk=0 t>400us
	btfsc CLK
	goto detect_start
	movlw h'3f'		;1	bylo 6f
detect_start1
	btfsc CLK
	goto detect_start
	movwf dpl		;przepisuja W do dpl 1
	decfsz dpl,0	;1 dekrement, wynik do W, jesli 0 pomin next instr.
	goto detect_start1	;1
	return
;**************************************************************************
	end
